#<utags_pm>(module de recherche dans la base hypertexte utags)[utags_pm_som]
# [utags_spe]
package utags;
use strict;

my %utags;
my $utags = 0;
my $debug = 0;
my $szCSV = "CSV_";
my @tableau; # 

BEGIN {
my @ligtags; # ligne tags champs TSV tabulation separated value
my $base=$ENV{"BASE"}; # chemin de la base mentor 
if($base eq ""){$base="~/Documents/mt";} # base mentor par defaut
my $ficutags=$base."/ht/utags";
#<chargement_du_fichier_utags_pm>()
if (length("$ficutags") )
{
open (utags, "< $ficutags") || die "can't open $ficutags : $!";
my @filetags = <utags>;
my $ii=0;
while ($filetags[$ii])
 {
  @ligtags = split(/\t/,$filetags[$ii]."\t");
  $utags{$ligtags[0]} = $ligtags[1];
  $ii++;
  if ($debug > 9) { printf(SHTM "%s,%s\n",$ligtags[0],$ligtags[1]);}
 }
if ($debug) { printf(SHTM "cardinal_de_utags=%d\n",$ii);}
}
}
END {
}
#<cherche_tag>(renvoie la ligne du fichier utags pointe par le tags)
sub cherche_tag
{
my $ref = shift;
return $utags{$ref};
}
#<TableauCharger>(renvoie le bloc ventuellement tableau CSV point par le tag sous forme d'un tableau perl)
sub TableauCharger
{
 my $a_tag = shift;      # etiquette du tableau
 my $le_nbl = shift;     # nombre de ligne du tableau
 my $les_lignes = shift; # tableau des lignes
 my $rszLigTag = shift;  # rfrence sur la ligne complte du tags  reconstruire

 my $filepath_tag=utags::cherche_tag($a_tag);
 my $ext_tag;
 my $file_tag;
 my $idebc;
 my $ii;
 my $jj;
 my $mot;
 my $debMot;
 my $nbCol;
 my $path_tag;
 my $ret;
 my $separ;
 my $szSep;
 my @tab_lig;

 #<ouverture_du_fichier_contenant_le_tag_utags_pm>()
 if (length("$filepath_tag") )
	{
	 open (STXT, "< $filepath_tag") || die "can't open $filepath_tag : $!";
	 util::basename($filepath_tag,\$path_tag,\$file_tag,\$ext_tag);
	}
my $liste_separ="<>{}\t\n";
my $liste_delim="";

# positionnement sur le bloc de tag recherch
while( $ret=sam::San(\$mot,$liste_separ,$liste_delim,\$separ,\*STXT) )
{
 if($mot eq $a_tag && $separ eq ">" )
	{
   $liste_separ="\n";
	 $mot = "";
   $ret=sam::San(\$mot,$liste_separ,$liste_delim,\$separ,\*STXT);
   ${$rszLigTag} = "<".$a_tag.">".$mot; # reconstruction de la ligne complte du tag
   $liste_separ="\n";
   $ret=sam::San(\$mot,$liste_separ,$liste_delim,\$separ,\*STXT);
   last;
	}
 $mot = "";
}
# lecture des lignes du bloc de tag : ici tableau
$ii=0; # indice ligne du tableau
$idebc=-1; # indice dans le tableau du tableau de la premire ligne de donnes
$szSep=";";
my $nNivBloc = 0; # niveau de bloc de pararenthse pour traiter les blocs imbriqus dans le bloc tableau  charger
$mot = "";
$liste_separ="\n\175\173"; # BUG: on enlve \173 sinon boucle infinie suppose
while( $ret=sam::San(\$mot,$liste_separ,$liste_delim,\$separ,\*STXT) )
{
 if($separ eq "\173" && util::trim($mot) eq "") # dtection d'un dbut de bloc (un dbut de bloc doit obligatoirement tre en dbut de ligne tout au moins il n'y a pas de mot avant sur la ligne.)
	{
   $nNivBloc++; # incrment du niveau de bloc de pararenthse
	}
 elsif($separ eq "\173" && util::trim($mot) ne "") # la parenthse ouvrante n'est pas un dbut de bloc mais du code.
	{
	 $debMot .= $mot.$separ; $mot = "";
	}
 if($separ eq "\175" && util::trim($mot) eq "") # dtection de la fin d'un bloc
	{
   $nNivBloc--; # dcrment du niveau de bloc de parenthse
   if($nNivBloc < 0) { last;} # dtection de la fin du bloc  charger
	}
 $mot = $debMot.$mot; $debMot = "";
 if($separ eq "\n") # dtection d'une fin de ligne du tableau
	{
	 @tab_lig = split (/$szSep/,$mot.$szSep);
   ${$les_lignes}[$ii] = $mot;
	 $nbCol=$#tab_lig;
	 for($jj = 0; $jj <= $nbCol; $jj++) {$tableau[$ii][$jj]=util::trim($tab_lig[$jj]);}
	 $mot = "";
   $ii++;
	}
}
close STXT;
${$le_nbl}=$ii; # nombre de ligne dans le tableau
return $filepath_tag;
}
#<BlocCharger>(renvoie le bloc ventuellement tableau CSV point par le tag sous forme d'un tableau perl)
sub BlocCharger
{
 my $a_tag = shift;      # etiquette du bloc
 my $le_nbl = shift;     # nombre de ligne du bloc
 my $les_lignes = shift; # tableau des lignes
 my $rszLigTag = shift;  # rfrence sur la ligne complte du tags  reconstruire

 my $filepath_tag=utags::cherche_tag($a_tag);
 my $ext_tag;
 my $file_tag;
 my $ii;
 my $jj;
 my $mot;
 my $debMot;
 my $nbCol;
 my $path_tag;
 my $ret;
 my $separ;
 my $szSep;
 my @tab_lig;
 #<ouverture_du_fichier_contenant_le_tag_utags_pm>()
 if (length("$filepath_tag") )
	{
	 open (STXT, "< $filepath_tag") || die "can't open $filepath_tag : $!";
	 util::basename($filepath_tag,\$path_tag,\$file_tag,\$ext_tag);
	}
my $liste_separ="<>{}\t\n";
my $liste_delim="";

# positionnement sur le bloc de tag recherch
while( $ret=sam::San(\$mot,$liste_separ,$liste_delim,\$separ,\*STXT) )
{
 if($mot eq $a_tag && $separ eq ">" )
	{
   $liste_separ="\n";
	 $mot = "";
   $ret=sam::San(\$mot,$liste_separ,$liste_delim,\$separ,\*STXT);
   ${$rszLigTag} = "<".$a_tag.">".$mot; # reconstruction de la ligne complte du tag
   $liste_separ="\n";
   $ret=sam::San(\$mot,$liste_separ,$liste_delim,\$separ,\*STXT);
   last;
	}
 $mot = "";
}
# lecture des lignes du bloc de tag
$ii=0; # indice ligne du tableau
my $nNivBloc = 0; # niveau de bloc de pararenthse pour traiter les blocs imbriqus dans le bloc tableau  charger
$mot = "";
$liste_separ="\n\175\173"; # BUG: on enlve \173 sinon boucle infinie suppose
while( $ret=sam::San(\$mot,$liste_separ,$liste_delim,\$separ,\*STXT) )
{
 if($separ eq "\173" && util::trim($mot) eq "") # dtection d'un dbut de bloc (un dbut de bloc doit obligatoirement tre en dbut de ligne tout au moins il n'y a pas de mot avant sur la ligne.)
	{
   $nNivBloc++; # incrment du niveau de bloc de pararenthse
	}
 elsif($separ eq "\173" && util::trim($mot) ne "") # la parenthse ouvrante n'est pas un dbut de bloc mais du code.
	{
	 $debMot .= $mot.$separ; $mot = "";
	}
 if($separ eq "\175" && util::trim($mot) eq "") # dtection de la fin d'un bloc
	{
   $nNivBloc--; # dcrment du niveau de bloc de parenthse
   if($nNivBloc < 0) { last;} # dtection de la fin du bloc  charger
	}
 elsif($separ eq "\175" && util::trim($mot) ne "") # la parenthse fermante n'est pas un dbut de bloc mais du code.
	{
	 $debMot .= $mot.$separ; $mot = "";
	}
 $mot = $debMot.$mot; $debMot = "";
 if($separ eq "\n") # dtection d'une fin de ligne du tableau
	{
   ${$les_lignes}[$ii] = $mot;
	 $mot = "";
   $ii++;
	}
}
close STXT;
${$le_nbl}=$ii; # nombre de ligne dans le tableau
return $filepath_tag;
}
#<utags_pm_fin>(fin du script perl)
1;
