#<mt_to_htm_pl>(gnration de page html  partir du format mentor)[mt_to_htm_pl_som]
#
# suivant les spcifications de [gnration_des_pages_html]
# cf [mt_to_htm_txh]
#
# historique:
# 23/07/2002 FXP cration - maroc - casablanca - avenue de bretagne prs du march Lajajma
# 24/08/2002 FXP tat satisfaisant - lecture avance d'un mot pour meilleur controle 
# 08/01/2003 FXP les paragraphes ne sont plus introduit sur les tiquettes mais sur les accolades
# 29/01/2003 FXP [edition_en_commentaire_de_la_liste_des_liens_de_la_page] liste_lien
# 26/06/2003 FXP ajout de la [numrotation_bloc_spe] [edition_de_la_numrotation_du_bloc]
# 01/07/2003 FXP [edition_d_une_etiquette_sans_commentaire_accole_a_une_autre_etiquette]
# 02/10/2003 FXP doublement du signe gal pour les types de bloc 
# 20/09/2004 FXP utilisation du module standard getopt
# 22/12/2004 FXP recherche dans [infixe_lst] pour les infixes au lieu des suffixes seulement
# 06/09/2007 FXP alimentation en sortie intermdiaire dans le buffer $szSHTM pour ne pas crire en permanence dans le fichier de sortie
# 21/11/2007 FXP [traitement_d_un_alias_url]
# 09/01/2008 FXP cas sparateur suivant parenthse: on retire les sparateurs modifieurs de blocs pour l'analyse de l'intrieur de la parenthse
# 15/01/2008 FXP [reconnaissance_automatique_des_url_spe]
# 12/02/2008 FXP [edition_d_une_etiquette_sans_commentaire_accole_un_bord_de_colonne_csv] corrige le bug sur les chanes sur bord de colonne
# 14/02/2008 FXP [commentaire_mentor_html_spe] correction du bug ancestral de dtection fausse des commentaires mentor gnrant des tiquettes sur une simple mise entre parenthse
# 29/04/2008 FXP [type_de_bloc_nomm_par_suffixe] on ne fait plus lowercase sur le mot parce que on dcide que la syntaxe est minuscule pour utiliser la majuscule "nomagic"
# 10/06/2014 FXP traitement des types de colonne invisible dans les tableaux [colonne_de_travail_spe]
# 01/01/2017 FXP ajout de liste_image
# 16/11/2017 FXP [gestion_de_la_variable_d_environnement_base_mentor]
# 24/02/2020 FXP ajout de [html_inline] utilisation de [utags_pm] fonction [BlocCharger]
# 01/12/2021 FXP ajout du fichier des paramtres cf [mt_to_htm_par]
#
#<utilisation_du_module_getopt_mt_to_htm>()
use lib "/home/minage/Documents/mt/fic/pl"; # sous linux mint les ajouts dans @INC par la variable d'environnement PERL5LIB ne semble pas tre pris en compte
use Getopt::Std;
use util;
use sam;
use utags; #  [utags_pm]

my $szREM = "#"; # commande commentaire pour le batch gnn cf SBATCH
my $szSHTM; # chane de sortie du HTML gnr
my $debug=0; # indicateur booleen d'affichage des messages de debug

#[fonctions_perl_exemple]()
sub trim {
 $_=shift;
 tr/\n/ /;
 s/^\s+//;
 s/\s+$//;
 $_;
}
sub str_ISO_ASCII {
 $_=shift;

 s///g;
 s///g;
 s///g;
 s///g;
 s///g;
 s///g;
 s///g;
 s///g;
 s///g;
 s///g;
 s///g;
 s///g;
 s///g;
 s///g;
 s///g;
 s///g;
 s///g;
 $_;
}
#[San](analyseur syntaxique)
sub San
{
 # arguments
 my $rs_mot = shift; # String,
 my $separateurs = shift; # String,
 my $delimiteurs = shift; # String,
 my $rs_separ = shift; # As String 

 # variable locale
 my $retour; # String
 my $sep; # String
 my $pos; # Integer
 my $car; # 
 my $fini; # Boolean
 my $deli; #

 while ( ($car = getc(STDIN)) ne "")
 {
  if( ($pos=index($delimiteurs, $car)) > -1 or $deli != 0 ) # c'est un dlimiteur
   {
    if( $pos != 0) { $deli = $pos;} # un dlimiteur de chaine est trouv
    elsif( substr($delimiteurs,$deli+1,1) eq $car) { $deli = 0;} # on trouve sa correspondance
    else { ${$rs_mot} = ${$rs_mot}.$car;}
    next;
   }
  elsif(index($separateurs, $car) > -1) # c'est un sparateur: fin du mot
   { 
    ${$rs_separ} = $car; last; 
   }
  else # a fait partie du mot
   {
    ${$rs_mot} = ${$rs_mot}.$car;
   }
 }
 return $car;
}

#<printTag>()
sub printTag
{
 # arguments
 $taille = shift; # taille de la police
 $tag = shift; # identifiant du bloc
 $tagTitle = shift; # titre du bloc
 $para = shift; # boolen dition d'un paragraphe
 $bNum = shift; # boolen dition de la numrotation 

#<edition_de_la_numrotation_du_bloc>()
 $szNum="";
 if($bNum == 1) 
 {
  $numer[$nivBloc[$iAcc]]++;
  for($jj = 1; $jj <= $nivBloc[$iAcc]; $jj++) 
   { $szNum .= $numer[$jj]."."; };
  $numer[$nivBloc[$iAcc]+1] = 0;
 }
 if($para >= 1) { $szPara = "\074P\076";} else { $szPara = "";}
 if($para == 2) { $szPara1 = "\074P\076";} else { $szPara1 = "";}
 # pour les tiquettes: midnigthblue 191970
 # pour les tiquettes: indigo 4B0082 
 $szSHTM .= sprintf("%s\074B\076\074FONT Color=\"#4B0082\" size=\"%d\"\076\074A NAME=\"%s\"\076%s%s\074/A\076\074/FONT\076\074/B\076%s",$szPara1,$taille,$tag,$szNum,ucfirst($tagTitle),$szPara);
 $tag = ""; $tagTitle = "";
}

#<GetPathLien>(rcupre le chemin du fichier qui contient le lien)
# cf [traitement_d_un_alias_url]
sub GetPathLien
{
 my $ref = shift;
 my $ficlien=$utags{$ref};
 my $raclien=substr($ficlien,0,2);
 my $pos=rindex($ficlien,"."); 
 my $extlien=substr($ficlien,$pos);
 my  $szFiclien = "";
 if($ficlien ne "")
  {
   if($iHTML{$extlien} >= 0 || $extlien eq ".som")
    {
     $ficlien =~ s/\./_/;
     $ficlien.= ".htm";
    }
   # <traitement_des_raccourci_url>()
   $szURL=util::trim($alias_liste{lc($raclien)});
   if( $szURL ne "")
    {
     $szFiclien =$szURL.substr($ficlien,2);
    }
   else
    {
     $szFiclien =$ficlien;
    }
  }
 return $szFiclien;
}

#<declaration_mt_to_htm>()
my $mot; # mot lu courant
my $pMot; # mot prcdent
my $s_mot; # mot lu suivant
my $separ; # sparateur qui a provoqu la fin de la lecture du mot 
my $e_separ; # copie de la variable $separ pour l'dition 
my $s_separ; # sparateur qui provoquera la fin de la lecture du mot suivant 
my $p_separ; # sparateur qui a provoqu la fin de la lecture du mot prcdent
my $p2Separ; # sparateur prcdent le sparateur prcdent
my $pBSepar; # sparateur de bloc prcdent
my $p2BSepar; # sparateur de bloc prcdent le sparateur de bloc prcdent
my @nivBloc; # tableau mmorisant le niveau de bloc pour les diffrents types de bloc (bracket, parenthses, accollades, crochet)
my @typBloc; # tableau mmorisant le type de bloc d'accolades (modifieur de bloc)
my $numChampChemin = 0; # -c numero , numro du champs "chemin du fichier" de la liste CSV des fichiers  traiter
my $numChampDossier = -1; # -d numero , numro du champs "dossier eureka du fichier" de la liste CSV des fichiers  traiter
my $iBra=0; my $iPar=1; my $iAcc=2; my $iCro=3;  # indices dans nivBloc des Bracket <>, Parenthse (), Accolades {}, Crochet []

my $lang = ""; # code langue pour un bloc [llea_spe] 
my $nbr_mot_tra; # <nbr_mot_tra> nombre de mot traduit dans un bloc [llea_spe]
my $indEdFinTab = 0; # <indEdFinTab>(indicateur d'dition des balises de fin de tableau)
my $couleur_fond = "F4FEFE"; # <couleur_fond>()  blanc lunaire [couleur_tab]

#<traitements_des_arguments_de_la_ligne_de_commande_mt_to_htm>()
getopts(':b:k:c:d:m:s:',\%opt); # <options_de_la_ligne_de_commande_mt_to_htm>()
$site=$opt{'s'}; # -s indique que l'on gnre les pages pour un site
$o_base=$opt{'m'}; # -m valeur de BASE transmise par l'appelant pour gnrer la page  partir d'une base spcifie (autre que la base courante)
if($o_base ne ""){$base=$o_base;} 
$cheminSite=$opt{'k'}; # -k chemin de destination des pages html pour le site distant,
$cheminSiteDos=&str_ISO_ASCII($cheminSite); # la version dos (ascii versus iso8859)
$numChampChemin=$opt{'c'}; # -c numero , numro du champs "chemin du fichier" de la liste CSV des fichiers  traiter
$numChampDossier=$opt{'d'}; # -d numero , numro du champs "dossier eureka du fichier" de la liste CSV des fichiers  traiter
if($numChampChemin eq "") { $numChampChemin=0;} # numrotation  partir de zero le premier champ est par dfaut le nom du fichier cf [domaine_mentor]
$cheminBatch=$opt{'b'}; # -b chemin complet du fichier de commande de livraison des pages html

#<initialisations_mt_to_htm>()
$p_dossier = "";
$date_jour=util::DateJour();
#<fichiers_parametres_mt_to_htm>()
if($base eq ""){$base=$ENV{"BASE"};} # chemin de la base mentor pris dans l'environnement
if($base eq ""){$base="g:\\mt";} # base mentor par defaut
$ficpar=$base."/ht/mt_to_htm_par.txt"; # fichier des paramtres de gnration des pages htlm
$ficutags=$base."/ht/utags";
$ficinfixe=$base."/ht/infixe.lst";
$ficext=$base."/ht/extensio.lst";
# $BASE/ht/tmp/mt_to_htm.
$ficlog=$base."/ht/tmp/mt_to_htm.log";
$ficalias=$base."/ht/alias_url.lst"; #[alias_url_lst]

printf("BASE=%s,date_jour=%s\n",$base,$date_jour);
#<ouverture_fichier_log_mt_to_htm>()
if($debug) { open(SLOG, "> $ficlog") || die "can't open".$ficlog." : $!";}

if($debug){ printf("ARGV=$ARGV[0]|\n");}
if(substr($ARGV[0],0,1) eq "@")
{
 $ficsource=substr($ARGV[0],1);
 util::basename($ficsource,\$pathSource,\$fileSource,\$extSource);
 printf("[ficsource=%s|pathSource=%s|fileSource=%s|extSource=%s]\n",$ficsource,$pathSource,$fileSource,$extSource);
 #<chargement_du_fichier_liste_de_fichier_a_traiter_mt_to_htm>()
 open (fsource, "< $ficsource") || die "can't open $ficsource : $!";
 @Source = <fsource>;
}
else # il s'agit d'un fichier unique  traiter
{
 $Source[0]=$ARGV[0];
if($debug){ printf(SLOG "source=$source[0]|\n");}
}
#<chargement_du_fichier_extensio_lst_mt_to_htm>()
open (fextensio, "< $ficext") || die "can't open $ficext : $!";
@file_extensio = <fextensio>;
$ii=0;
while ($file_extensio[$ii])
 {
  @lig_extensio = split(/;/,$file_extensio[$ii].";");
  $iHTML{util::trim($lig_extensio[0])} = util::trim($lig_extensio[4]);
  $commSrc{util::trim($lig_extensio[0])} = util::trim($lig_extensio[6]);
  $ii++;
 }
if($debug) { printf(SLOG "cardinal_de_extensio_lst;%d\n",$ii);}

#<chargement_du_fichier_des_parametres_mt_to_htm>()
if (length("$ficpar") )
{
open (fpar, "< $ficpar") || die "can't open $ficpar : $!";
@filepar = <fpar>;
$ii=0;
while ($filepar[$ii])
 {
  chomp $filepar[$ii];
  @ligpar = split(/=/,$filepar[$ii]);
  $param{$ligpar[0]} = $ligpar[1];
  $ii++;
 }
if($debug) { printf(SLOG "cardinal_de_%s;%d\n",$ficpar,$ii);}
}

#<chargement_du_fichier_utags_mt_to_htm>()
if (length("$ficutags") )
{
open (futags, "< $ficutags") || die "can't open $ficutags : $!";
@filetags = <futags>;
$ii=0;
while ($filetags[$ii])
 {
  @ligtags = split(/\t/,$filetags[$ii]."\t");
  $utags{$ligtags[0]} = $ligtags[1];
  $ii++;
 }
if($debug) { printf(SLOG "cardinal_de_utags;%d\n",$ii);}
}

#<chargement_du_fichier_infixe_lst_mt_to_htm>()
open (finfixe_liste, "< $ficinfixe") || die "can't open $ficinfixe : $!";
@file_infixe = <finfixe_liste>;
$ii=0;
while ($file_infixe[$ii])
 {
  @lig_infixe = split(/;/,$file_infixe[$ii].";");
  $lig_infixe[1] =~ s/\n//;
  $infixe_liste{$lig_infixe[0]} = $lig_infixe[1];
  $ii++;
 }
if($debug) { printf(SLOG "cardinal_de_infixe_lst=%d\n",$ii);}

#<chargement_du_fichier_alias_url_lst_mt_to_htm>()
open (falias_liste, "< $ficalias") || die "can't open $ficalias : $!";
@file_alias = <falias_liste>;
$ii=0;
while ($file_alias[$ii])
 {
  @lig_alias = split(/;/,$file_alias[$ii].";");
  $lig_alias[1] =~ s/\n//;
  $alias_liste{$lig_alias[0]} = $lig_alias[1];
  $ii++;
 }
if($debug) { printf(SLOG "cardinal_de_alias_lst=%d\n",$ii);}

#<ouverture_du_fichier_batch_de_livraison_a_generer_mt_to_htm>()
if($cheminBatch ne "") 
{ 
 open(SBATCH, "> $cheminBatch") || die "can't open".$cheminBatch." : $!";
 $cheminBatch =~ s/.*\\//;
 $cheminBatch =~ s/\./_/;
 printf(SBATCH "REM \074%s\076(ATTENTION: ne pas modifier: fichier de commande gnr pour livraison page HTML liste_doc_chorus_pour_eureka_txt)\n",$cheminBatch);
}
#==================================================================================================
#<boucle_sur_les_fichiers__traiter>  soit 1 sur ligne de commande, soit liste simple, ou liste CSV
$iis=-1;
while ($Source[++$iis])
{
# reinitialisation variables
#<initialisation_mt_to_htm>()
@nivBloc=(0,0,0,0); # <nivBloc>(compteur des niveaux des diffrents types de blocs)
$nivBlocCsv=0; # niveau de bloc pour les blocs de type CSV permet de grer les tableaux et sous-tableau
$iCol=-1;  # numero de colonne sql
$iCom=0;  # <iCom> indicateur de type d'tiquette hypertexte, de 3  8 lien html avec url explicite, 1 tiquette mentor
          # 2 tiquette mentor avec un commentaire de type suite  intgrer  dans le code HTML
$nivPar=0; # niveau de parenthse
$sepIni=" \n\t,:.\""; # liste des sparateurs par dfaut
$sepSpe="\\"; # liste sparateurs spcial
$sepMod=";-`*%_=!@#&"; # liste des sparateurs modifieurs de blocs
$sepBloc="><)(}{]["; #  liste des sparateurs de blocs
$sep=$sepIni.$sepBloc.$sepMod.$sepSpe; # liste globale des sparateurs par dfaut
$szT=4; # taille du texte
$szTiT=$szT+2; # taille maximum des titres 
$trt=1; # indicateur de traitement de formatage: sert  interrompre la mise en forme dans diffrent cas: commentaire html
$ppR=""; # couleur de fond pour les "nouveaux" textes des tableaux 
$iStep=0; # initialisation tape syntaxique (0 valeur initiale, 1 head, 2 body)
my $szFont = "ARIAL";
my $szColor = "";
%liste_lien = ();
%liste_image = ();
# initialisation <numer>(tableau de numrotation des niveaux d'accolades: chapitre, sous-chapitre,...)
@numer = ();
# traitement de la ligne de la liste des fichiers
if (index($Source[$iis],";") == -1 )   # ce n'est pas un enregistrement CSV
 {
  if(index("{#}",substr($Source[$iis],0,1)) == 0) {next;}# ligne qui ne sont pas des chemins de fichier [boucle_sur_les_fichiers__traiter]
  $ficin = util::trim($Source[$iis]);
 }
else # la liste de source  traiter a un format CSV
 {
  @ligneSource = split(/;/,$Source[$iis].";");
  if(index("{#}",substr($Source[$iis],0,1)) == 0) {next;} # ligne qui ne sont pas des chemins de fichier
  if($Source[$iis] =~ /^CSV/ ) {next;} # saut des spcifications des tableaux csv cf [traite_csv]
  $ficin = util::trim($ligneSource[$numChampChemin]);
  if( $numChampDossier != -1 )
   {
    $p_dossier = $dossier;
    $dossier = util::trim($ligneSource[$numChampDossier]); # le sous-dossier de destination est dans le nime champs csv de la liste 
   }
  if($cheminBatch ne "") 
   { 
    if($p_dossier ne $dossier) 
     {
      $command=sprintf("if not exist %s/%s mkdir %s/%s\n",$cheminSiteDos,$dossier,$cheminSiteDos,$dossier);
if($debug) { printf(SLOG "debug:if not exist %s/%s mkdir %s/%s\n",$cheminSiteDos,$dossier,$cheminSiteDos,$dossier);}
      $command=&str_ISO_ASCII($command);
      printf(SBATCH $command);
      #<bug_mt_to_htm_pl_000_raf_img>(p:\mt\fic\gif\underconst.gif)
      #{ la commande ne semble pas marcher
      #system($command);
      #}
     }
   }
 }

$pos=index($ficin,".");
$ext=substr($ficin,$pos,4);

if($debug) { printf(SLOG "source;%s\n",$ficin);}
#<lecture_du_fichier_d_entree_mt_to_htm>(on lit le fichier spcifi en argv[0] ou stdin)
if (length("$ficin") )
{
 if(!open (STDIN, "< $ficin"))
  {
if($debug) { printf(SLOG "can't open %s\n",$ficin);}
   next;
  }
}
else
{
 next;
}
#<controle_de_generation_des_pages_html_par_l_extension>()
if($iHTML{$ext} < 0) # cf [gen_html]
{
 #<ecriture_dans_le_fichier_batch_de_commande_de_livraison_mt_to_htm>()
 if($cheminBatch ne "") 
  { 
   if($p_dossier ne $dossier) 
    {
     $command=sprintf("if not exist %s/%s mkdir %s/%s\n",$cheminSiteDos,$dossier,$cheminSiteDos,$dossier);
     $command=&str_ISO_ASCII($command);
     printf(SBATCH $command);
     system($command);
    }
   printf(SBATCH "copy %s %s/%s\n",$ficin,$cheminSiteDos,$dossier);
  }
  next;
}
else
{
 # nom du fichier html gnr
 $ficout=$ficin;
 $ficout =~ s/\./_/;
 $ficout.= ".htm";
 if($cheminSite ne "") 
  { 
   $ficout =~ s/.*\///;
   if($dossier eq "") 
    { 
     $ficout = sprintf("%s/%s",$cheminSite,$ficout);
     if($cheminBatch ne "") 
      { 
       printf(SBATCH "% gnration pralable de %s/%s\n",$szREM,$cheminSiteDos,$ficout);
if($debug) { printf(SLOG "debug:% gnration pralable de %s/%s\n",$szREM,$cheminSiteDos,$ficout);}
      }
    }
   else
    { 
     $ficout = sprintf("%s\\%s\\%s",$cheminSite,$dossier,$ficout);
     if($cheminBatch ne "") 
      { 
       printf(SBATCH "% gnration pralable de %s/%s/%s\n",$szREM,$cheminSiteDos,$dossier,$ficout);
if($debug) { printf(SLOG "debug:% gnration pralable de %s/%s/%s\n",$szREM,$cheminSiteDos,$dossier,$ficout);}
      }
    }
  }
if($debug) { printf(SLOG "output;%s\n",$ficout);}
 #<ouverture_du_fichier_de_sortie_gnr_mt_to_htm_pl>()
 if(!open (SHTM, "> $ficout")) { print "can't open".$ficout." : $!"; next;}

 if($iHTML{$ext} == 1) # cf [gen_html][gestion_de_la_preservation_du_texte]
  { 
   $iPre=3;
   $szFont = "COURRIER"; # le courrier
   $szSHTM .= sprintf("\074B\076"); # ... en gras 
   $szSHTM .= sprintf("\074PRE\076\074FONT FACE=\"%s\"SIZE=%d\076\n",$szFont,$szT+1);
   $szTiT=$szT; # taille maximum des titres 
  }
}
#<detection_d_un_document_de_type_source>(:donc avec gestion des commentaires)
if($commSrc{$ext} ne "") # il y a un commentaire: c'est un langage source
{
 # traitement de la chaine qui dfinit le commentaire selon [comm_src]
 if($pos=index($commSrc{$ext},",") != -1 )
  {
   $debCom=substr($commSrc{$ext},0,$pos+1);
   $finCom=substr($commSrc{$ext},$pos+2);
  }
 else
  {
   $debCom=$commSrc{$ext};
   $finCom="\n";
  }
}
$meserrsyn="erreur syntaxique: ";
$meserr1="";


#===============================================================================================================#
# syntaxe: <mot_mot>(mot mot){;mot,mot [mot] }                                                                  #
# tapes:                                                                                                       #
#===============================================================================================================#
#<analyse_de_STDIN_mt_to_htm>()
if($debug) { printf(SLOG "debut [analyse_de_STDIN_mt_to_htm]\n");}
$szSHTM .= sprintf("\074HTML\076\n");
$szSHTM .= sprintf("\074meta http-equiv=\042Content-Type\042 content=\042text/html; charset=%s\042 /\076\n",$param{"CHARSET"});
#<edition_en_commentaire_des_informations_de_gnration_mt_to_htm_pl>()
$szSHTM .= sprintf("\n\074P\076\n\074!---\n page html gnre le %s par mt_to_htm.pl  partir d'un fichier hypertexte mentor",$date_jour);
$szSHTM .= sprintf("\n pour toute information sur mentor,mt_to_htm,utags cf http://quantique.org/mentor_net_index_txh.htm");
$szSHTM .= sprintf("\n---\076");

$ret=&San(\$s_mot,$sep,"",\$s_separ);
$ret="\255";
#<boucle_d_analyse_du_document_source_mt_to_htm>()
while(1)
 {
  $bGras=0; # la mise en gras n'est valable que pour un mot cf [gestion_des_caractres_en_gras]
  #<trace_detaille_de_l_analyse>()
  #<gestion_des_separateurs_et_mots_prcdents>()
  $p2Separ = $p_separ;
  $p_separ = $separ;
  $pMot = $mot;
  $mot = "";
  if(index($sepBloc,$p_separ) != -1 )
   { 
    $p2BSepar = $pBSepar;
    $pBSepar = $p_separ;
   }
  if(index($sepMod,$p_separ) != -1 )
   { 
    $p2MSepar = $pMSepar;
    $pMSepar = $p_separ;
   }
   # si une ligne vide on annulle les sparateurs de blocs
  if($p_separ eq "\n" && $p2Separ eq "\n")
   { 
    $p2BSepar = "";
    $pBSepar = "";
   }
  #<lecture_du_mot_suivant>(: mot est le mot courant s_mot est le mot suivant idem pour separ et s_separ)
  $mot=$s_mot; $separ=$s_separ; $e_separ=$s_separ;
  $s_mot = "";
  $ret=&San(\$s_mot,$sep,"",\$s_separ);
if($debug){ printf(SLOG "[mot=$mot|s_mot=$s_mot|pMot=$pMot|separ=$separ|s_separ=$s_separ|e_separ=$e_separ|p_separ=$p_separ|p2separ=$p2separ|pBsepar=$pBsepar|p2Bsepar=$p2Bsepar]\n");}
  if(!$ret) { last;}
  #<traitement_des_mots_cls>(){
  #<ligne_sparatrice>()
  if(index($mot,"") > -1) { $mot = "\074HR\076\074BR\076";}
  #<mot_cle_de_tableau_csv>()
  if( $mot eq "CSV" && $separ eq "_" && $typBloc[$nivBloc[$iAcc]] eq ";")
   {
    next; # si on est dans un tableau CSV et que l'on rencontre la chane CSV c'est qu'il s'agit d'une ligne de spcification CSV on lira son type  la prochaine occurence.
   }
  #<filtrage_des_mot_cl_du_tableur_CSV> [traite_csv_pl]
  if( $pMot eq "CSV" && $p_separ eq "_" && $typBloc[$nivBloc[$iAcc]] eq ";" && $separ eq ":" )
   {
    my $csv_spe = substr($mot,0,3);
    if( $csv_spe eq "COL" || $csv_spe eq "TOT"  || $csv_spe eq "RPP"  || $csv_spe eq "RPT" || $csv_spe eq "COM" || $csv_spe eq "STA" )
     {
      $iHead = 1;
      # couleur tableau SteelBlue 4682B4
      $szSHTM .= sprintf("\074tr BGCOLOR=\"#4682B4\"\076\074th\076");
      #$szSHTM .= sprintf("\074tr BGCOLOR=\"#CC9966\"\076\074th\076");
      next;
     }
    elsif( $csv_spe eq "REG" || $csv_spe eq "CUM" || $csv_spe eq "FOR" || $csv_spe eq "TRI" || $csv_spe eq "SEL" || $csv_spe eq "UPD" || $csv_spe eq "KEY" || $csv_spe eq "TYP"
        || $csv_spe eq "VAR" || $csv_spe eq "EXE" || $csv_spe eq "EDT" || $csv_spe eq "VAR" || $csv_spe eq "OPT"
        || $csv_spe eq "GRP" || $csv_spe eq "IMP" || $csv_spe eq "INS" ) # cf [_CSV][CSV_REG]
     {
      $ret=&San(\$s_mot,"\n","",\$s_separ); # lecture de la ligne complte car elle n'est pas dit dans la page HTML
      if( $csv_spe eq "TYP" ) # <detection_de_sous_type_w>() dans la spcification [CSV_TYP] pour filtrage des colonnes  la gnration [colonne_de_travail_spe]
       {
        @typeCSV = split (/;/,$s_mot.";"); # CSV_TYP: dans s_mot la ligne CSV contenant les types des colonnes
       }
      $s_mot = "";
      next;
     }
   }
  #}
  #<traitement_de_diffrents_cas_de_sparateurs>(: et de leur squence){
  if(index($typeCSV[$nColCsv],"w") != -1) # <la_colonne_est_a_filtrer> [sous_type_csv_w]
   {
    $mot = ""; $e_separ = "";
   }
  if(($separ eq "\n") && ($typBloc[$nivBloc[$iAcc]] eq ";" || $nivBlocCsv >0 )) # <champs_tableau_csv_fin_de_ligne>(fin de ligne)
   {
    if($iHead == 1)
     { $iHead = 0;}
    $szSHTM .= sprintf("%s",$mot);
    $szSHTM .= sprintf("\074/tr\076\n\074tr%s\076",$ppR);$nbEnr++;
    if(1==0 && $bEnreg == 0 && $s_separ ne " " && $nbEnr >= 4) # <fusion_de_cellules>[fusion_de_cellules_tec]annul
     { $szSpan=" colspan=\"36\"";} else {$szSpan="";}
    $szSHTM .= sprintf("\074%s%s%s\076",($iHead == 1 ? "th" : "td"),$szTdAttr,$szSpan);
    if($s_separ ne " " )
      { $bEnreg = 0;} # initialisation car fin de ligne dans tableau
    $nColCsv = 0; # remise  zro du numro de la colonne CSV (traitement du [sous_type_csv_w]
    next;
   }
  if(($separ eq ";" ) && ($typBloc[$nivBloc[$iAcc]] eq ";" || $nivBlocCsv >0 ) ) # <champs_tableau_csv>() [champs_tableau_csv_fin_de_ligne]
   {
    if($mot ne "") { $szSHTM .= sprintf("%s",$mot);}
    else { $szSHTM .= sprintf("&nbsp;");} # edition d'un blanc inscable pour forcer l'affichage de la case du tableau si vide
    if($separ eq "\n") # <enregistrement_tableau_csv>()
     {
      if($iHead == 1)
       {  $iHead = 0;}
      $szSHTM .= sprintf("\074/tr\076\n\074tr%s\076",$ppR);
     }
    if(!($s_separ eq "\n" ))
     {
      $szSHTM .= sprintf("\074%s%s\076",($iHead == 1 ? "th" : "td"),$szTdAttr);
     }
    $bEnreg = 1; $szSpan="";# il s'agit d'un enregistrement csv et non d'une ligne de texte incluse [fusion_de_cellules_tec]
    $nColCsv++;# incrment du numro de la colonne CSV (traitement du [sous_type_csv_w]
    next;
   }
#______________________________________________________________________________________________________
# 24/10/2006 FP ces lignes de codes sont obscures on les supprime pour retrouver leur causes
# elles ne font que perturber les tableaux en introduisant des BR
# probablement un contournement de problme rsolu ensuite par ailleurs: bad programming
# 31/01/2016 FP probablement pour ne pas diter des lignes vides dans les tableaux (saut des spcifications non dites)
# if(($separ eq " " && $p_separ eq " " && $p2Separ eq "\n" && $mot eq "") #<cas_de_retour__la_ligne>()
#    || ($separ eq "\t" && $p_separ eq "\n" && $mot eq "") 
#   )
#  {
#   if($iComHTML == 0 && $typBloc[$nivBloc[$iAcc]] eq ";") # dclassement retour  la ligne
#    { $szSHTM .= sprintf("\074BR\076");}
#  }
#______________________________________________________________________________________________________
  if( $separ eq "\n" && $p_separ eq "." && $mot eq "")
   {
    $szSHTM .= sprintf("\074BR\076");
   }
  if($separ eq ":" && $iCom == 1 && $mot eq "" && $p_separ eq "(" ) 
   {
    $iCom = 2;# dtection de l'edition d'un commentaire de type suite
   }
  if($mot eq "" && $p_separ eq "\173" && index($sepMod,$separ) != -1 ) #<cas_des_modifieurs_de_bloc>(cf [modifieur_de_bloc])
   {
    $typBloc[$nivBloc[$iAcc]] = $separ; # mmorisation du type du bloc du niveau en cours
    if($separ eq ";") { $nivBlocCsv++;}
    if($separ eq "_") # <cas_commentaire_html>([fin_commentaire_html])
     {
      if($s_separ eq "_") # <cas_ommission>([fin_cas_ommission])
       {
       }
      else
       {
        $szSHTM .= sprintf("\074!---"); $iComHTML++;$trt = 0;
       }
     }
    elsif($separ eq "@") # <cas_inside_html>([fin_inside_html])
     {
      $trt = 0; 
      next; # on n'imprime pas le sparateur @
     }
    elsif($separ eq ";") # <cas_tableau_csv>()
     {
      # [couleur_fond]
      $indEdFinTab = 0; # rinitialisation de l'indicateur d'dition des balises de fin de tableau [cas_fin_tableau_csv_tec]
      $szSHTM .= sprintf("\074FONT FACE=\"SYSTEM\" SIZE=%d\076\n",$szT-1);
      $szSHTM .= sprintf("\074table BGCOLOR=\"%s\" border=\"1\" align=\"down\" cellspacing=\"0\"\076",$couleur_fond);
      #$szSHTM .= sprintf("\074table BGCOLOR=\"#FFFF99\" width=\"100%\" border=\"1\" align=\"down\" cellspacing=\"0\"\076");
      $bEnreg = 1; $szSpan="";# initialisation dtection ligne incluse [fusion_de_cellules_tec]
      $nbEnr=0;
      $nColCsv = 0; # initialisation du numro de la colonne CSV - traitement du [sous_type_csv_w]
      next;
     }
    elsif($separ eq "-") # <cas_puces>()
     {
      $szSHTM .= sprintf("\074UL\076\074LI\076");
      next;
     }
    elsif($separ eq "`") # <cas_puces_numerotes>()
     {
      $szSHTM .= sprintf("\074OL\076");
      next;
     }
    elsif($separ eq "=" or $separ eq "#" or $separ eq "&" ) # <cas_preservation_forme_du_texte>()
     {
      $szFont = "ARIAL";
      if ($s_separ eq "=" || $s_separ eq "\173") 
       { $szFont = "SYSTEM";$s_separ="";
         $szSHTM .= sprintf("\074B\076"); # le courrier en gras 
         $typBloc[$nivBloc[$iAcc]] = "";
       }
      $szSHTM .= sprintf("\074PRE\076\074FONT FACE=\"%s\"SIZE=%d\076\n",$szFont,$szT);
      if($iPre != 3) {$iPre=2;}
      next;
     }
    elsif($separ eq "") # <cas_lecture_convergente>() macro vim [lc]
     {
      $szConverge = "";
      # dbut du tableau bicolonne
      $szSHTM .= sprintf("\074FONT FACE=\"SYSTEM\" SIZE=%d\076\n",$szT-1);
      $szSHTM .= sprintf("\074table BGCOLOR=\"#C0C0C0\" border=\"1\" align=\"down\" cellspacing=\"0\"\076");
      # premire colonne
      $szSHTM .= sprintf("\074tr\076");
      $szSHTM .= sprintf("\074td\076");
      printf(SHTM $szSHTM); $szSHTM = ""; 
     }
    elsif($separ eq "") # <cas_llea>() [llea]
     {
      $ret=&San(\$s_mot,"\n","",\$s_separ); # lecture du code langage
		  $lang=$s_mot;
		  $s_mot = "";
		  $s_separ = "";
			$ficdic = $base."\\doc\\tex\\".$lang."_dic.txt";
			# todo: controler si changement de dico ou si dj charger <dico_raf_img>(g:\mt\fic\gif\underconst.gif)
			#<chargement_du_dictionnaire_langue_mt_to_htm>()
      if(open (dictionnaire, "< $ficdic") ) # si le dictionnaire est prsent
			 {
				my $mot_dico; # mot en entre du dictionnaire
				my $prev_mot_dico; # mot en entre du dictionnaire
				my $tra_dico; # traduction du mot
				@file_dico = <dictionnaire>;
				$ii=0;
				while ($file_dico[$ii]) # boucle sur les lignes du dictionnaire
				 {
					if(index($file_dico[$ii],";") != -1 ) # si il s'agit d'un enregistrement CSV
					 {
						@lig_dico = split(/;/,$file_dico[$ii].";");
						$lig_dico[1] =~ s/\n//;
            $mot_dico = util::trim(lc($lig_dico[0]));
				    if($prev_mot_dico eq $mot_dico)
						 {
						  $tra_dico .= ", ".util::trim(lc($lig_dico[1]));
						 }
						else
						 {
						  $tra_dico = util::trim(lc($lig_dico[1]));
						 }
						$dico_liste{$mot_dico} = $tra_dico;
				    $prev_mot_dico = $mot_dico;
					 }
					$ii++;
				 }
if($debug) { printf(SLOG "cardinal_du_dictionnaire=%d\n",$ii);}
			 }
     }
   }
  if($mot eq "" && $p_separ eq "(" && index($sepMod,$separ) != -1 ) #<cas_modifieur_d_affichage>([modifieur_d_affichage_du_texte])
   {
    $typAff[$nivBloc[$iPar]] = $separ; # mmorisation du type du bloc du niveau en cours
    if($separ eq "*" || $separ eq "\%" || $separ eq "") # <cas_nouveaux>([fin_nouveau_texte])<cas_couleur><cas_obsolete>()
     {
      if($separ eq "") { $szColor = $couleur_fond; } # gris
      elsif($separ eq "*")  { $szColor = "CC0000"; } # rouge cas % ou *
      elsif($separ eq "\045" && $iCom == 5)   # <annulation_cas_couleur>() (c'est une variable d'environnement)
			 { 
				$typAff[$nivBloc[$iPar]] = ""; 
        $szSHTM .= sprintf("\074/font\076");
			 }
      elsif($separ eq "\%" && $s_separ ne "\%")  { $szColor = "CC0000"; } # rouge cas % ou *
      if($typBloc[$nivBloc[$iAcc]] ne ";" ) # hors d'un tableau
       {
        $szSHTM .= sprintf("\074font color=\"#%s\"\076",$szColor);
       }
      else
       {
        $ppR=" BGCOLOR=\"#FF9966\"";
        $szSHTM .= sprintf("\074/tr\076\n\074tr%s\076\074td\076",$ppR);
        if($s_separ eq "\n") { $s_separ = "";}
       }
     }
    if($separ eq "#" && $s_mot ne "") 
     {
      $szColor = $s_mot; # couleur spcifie
      # $szSHTM .= sprintf("\074font color=\"#%s\"\076",$szColor);
      $szSHTM .= sprintf("\074font style=\"BACKGROUND-COLOR:#%s\"\076",$szColor);
      $s_mot = "";
     }
    if($separ eq "!") # <cas_gras>([fin_texte_gras])
     {
      $szSHTM .= sprintf("\074B\076");
     }
    next;
   }
  if($separ eq ":" && $s_mot eq "" && $s_separ eq ":" ) #<cas_deux_double_points_en_fin>(: [gestion_des_caractres_en_gras])
   {
    $bGras=1;
   }
  if($separ eq "") # <cas_saut_de_page>()
   {
    $szSHTM .= sprintf("\074P STYLE=\"page-break-before: always;\"\076\n");
    next;
   }
  #}
  if($separ eq "(" && $p_separ eq ">" && $mot eq "") # <cas_parenthese_ouvrante_suivante>()
   {
    $sep=$sepIni.$sepBloc.$sepSpe; # on retire les sparateurs modifieur de blocs
   }
  if($s_separ eq ")") # <cas_parenthese_fermante_suivante>()
   {
    $sep=$sepIni.$sepBloc.$sepMod.$sepSpe; # on remet les sparateurs modifieur de blocs
   }
#<switch_separateur>(:traitement de cas exclusif) spar en deux cas: {
#<cas_de_separateur_gerant_les_etiquette_ou_reference_hypertexte>(){
  #<cas_infrieur>(: debut de [traitement_d_une_etiquette])
  if($separ eq "\074" && ( $s_separ eq "_"  || $s_separ eq "\076" )) 
   {
    $nivBloc[$iBra]++;
    $szSHTM .= sprintf("%s",$mot);
   }
  elsif($separ eq "\076" && $nivBloc[$iBra] > 0 && ( $p_separ eq "_"  || $p_separ eq "\074" )) #<cas_suprieur>(:fin de [traitement_d_une_etiquette])
   {
    if( $s_separ eq "\074" &&  ( $p_separ eq "_"  || $p_separ eq "\074" )) #<edition_d_une_etiquette_sans_commentaire_accole_a_une_autre_etiquette>()
     {
      $tag .= $mot;
      &printTag($szT,$tag,"",0,0);
      $mot = "";
     }
    elsif( ($s_separ eq ";" && ($typBloc[$nivBloc[$iAcc]] eq ";" || $nivBlocCsv >0 ))
        &&  ( $p_separ eq "_"  || $p_separ eq "\074" )) #<edition_d_une_etiquette_sans_commentaire_accole_un_bord_de_colonne_csv>()
     {
      $tag .= $mot;
      &printTag($szT,$tag,$tag,0,0);
      $mot = "";
     }
    $nivBloc[$iBra]--;
    $attribut = "";
    #[type_de_bloc_nomm_par_suffixe]
    #  29/04/2008 FP debut - on ne fait plus lowercase sur le mot parce que on dcide que la syntaxe est minuscule pour utiliser la majuscule "nomagic"
    #$typb = lc($mot);
    $typb = $mot;
    #  29/04/2008 FP fin
    if($p_separ eq "_" && $typb eq "web")
     {
      $iCom = 3; $protocole = "http://"; # lien protocole http
     }
    elsif($p_separ eq "_" && $typb eq "webs")
     {
      $iCom = 3; $protocole = "https://";  # lien protocole https
     }
    elsif($p_separ eq "_" && $typb eq "nweb")
     {
      $iCom = 3; $protocole = "http://"; $attribut = $param{"MOD_NAV"}; # lien protocole http
     }
    elsif($p_separ eq "_" && $typb eq "nwebs")
     {
      $iCom = 3; $protocole = "https://"; $attribut = $param{"MOD_NAV"}; # lien protocole https
     }
    elsif($p_separ eq "_" && $typb eq "file")
     {
      $iCom = 4; $protocole = "file://"; # lien protocole file
     }
    elsif($p_separ eq "_" && $typb eq "nfile")
     {
      $iCom = 4; $protocole = "file://"; $attribut = $param{"MOD_NAV"}; # lien protocole file
     }
    elsif($p_separ eq "_" && $typb eq "one")
     {
      $iCom = 4; $protocole = "onenote://"; # lien protocole onenote
     }
    elsif($p_separ eq "_" && $typb eq "none")
     {
      $iCom = 4; $protocole = "onenote://"; $attribut = $param{"MOD_NAV"}; # lien protocole onenote
     }
    elsif($p_separ eq "_" && $typb eq "img")
     {
      $iCom = 5; $protocole = "file://"; # lien protocole file image
     }
    elsif($p_separ eq "_" && $typb eq "wimg")
     {
      $iCom = 5; $protocole = "http://"; # lien protocole file
     }
    elsif($p_separ eq "_" && $typb eq "ftp")
     {
      $iCom = 6; $protocole = "ftp://"; # lien protocole ftp
     }
    elsif($p_separ eq "_" && $typb eq "mailto")
     {
      $iCom = 7; $protocole = "mailto"; # lien protocole file
     }
    elsif($p_separ eq "_" && $typb eq "son")
     {
      $iCom = 8; $protocole = "bgsound"; # lien protocole file
     }
    else
     {
      $tag .=$mot;
      if($p_separ eq "_" && $typb eq "pla")
       {
        $szTdAttr .= " nowrap"; # <tableau_de_type_planning>(: attribut nowrap dans les cellules td)
       }
      # <traitement_des_infixes_d_etiquette>()
      if( index("\074_\076",$p_separ) != -1 && ($lib_infixe=$infixe_liste{$mot}) ne "")
       {
        $tagTitle =$lib_infixe." ".$tagTitle;
       }
      else
       {
        $tagTitle .=$mot;
       }
     }
   }
  elsif($separ eq "[") # <cas_crochet_ouvrant>(: [traitement_d_une_reference])
   {
    $nivBloc[$iCro]++;
    $szSHTM .= sprintf("%s",$mot);
   }
  elsif($separ eq "]" && $nivBloc[$iCro] > 0) # <cas_crochet_fermant>(:[traitement_d_une_reference])
   {
    $nivBloc[$iCro]--;
    $ref .=$mot;
    if( index("_",$p_separ) != -1 && $mot eq "hil") # <cas_html_inline> [html_inline_spe]
     {
      my @tabInline; # tableau des lignes du bloc inline 
      my $nTabInline = 0; # nombre de lignes du bloc inline 
      my $szLigTag; # ligne gnre du tags inline
      if($trt == 1 ) { $trt = -1;} # cas [inline_html] : on inhibe l'dition du lien html 
      # <chargement_du_tableau_source_de_l_inline>()
      utags::BlocCharger($ref,\$nTabInline,\@tabInline,\$szLigTag);
      for( my $inl = 0; $inl <= $nTabInline; $inl++) # 
       {
        $szSHTM .= sprintf("%s",$tabInline[$inl]);
       }
     }
    elsif( index("[]_",$p_separ) != -1 && ($lib_infixe=$infixe_liste{$mot}) ne "") # <traitement_des_infixes_de_reference>()
     {
      $refTitle =$lib_infixe." ".$refTitle;
     }
    else
     {
      $refTitle .=$mot;
     }
    if($trt > 0 ) #<dition_d_un_lien_html_mt_to_htm>()  $trt peut valoir 0 cas commentaire ou -1 cas inline_html
     {
      $ficpath=$utags{$ref};
      $ficlien=&GetPathLien($ref);
      my $protocole = "file://";
      if($site ne "") # <edition_d_un_lien_file>(: si publication sur un site le lien file devient un http sur le rpertoire local)
       {
        my $filepath_tag=$ficlien;
        my $ext;
        my $file;
        my $path;
        util::basename($filepath_tag,\$path,\$file,\$ext);
        $ficlien = $file.".".$ext;
        $protocole = "";
       }
      if($ficlien eq "") # le lien n'existe pas dans la base: on n'dite pas un lien
       {
        $szSHTM .= sprintf("%s",$ref);
       }
      elsif(substr($ficlien ,-3,3) ne "htm") #<rfrence_vers_du_texte_non_html>()
       {
        my $szURL=$ficlien;
        $szURL =~ s/\\\\/\\/g;
        $szSHTM .= sprintf("\074A HREF=\"%s%s\"\076%s\074/A\076",$protocole,$szURL,$refTitle);
       }
      elsif( lc($ficin) eq lc($ficpath) ) # <rfrence_intrapage>()
       {
        $szSHTM .= sprintf("\074A HREF=\"#%s\"\076%s\074/A\076",$ref,$refTitle);
       }
      elsif($iStep == 0 && $nivBloc[$iAcc] == 0 ) # <rfrence_extrapage_du_sommaire>(et liens sources)
       {
      # couleur de fond gainsboro DCDCDC
      $szSHTM .= sprintf("\n\074HEAD\076\n\074TITLE\076%s\074/TITLE\076\n\074/HEAD\076\n",$comMent);
      $szSHTM .= sprintf("\074BODY BGCOLOR=\"%s\" TOPMARGIN=\"50\" BOTTOMMARGIN=\"50\" LEFTMARGIN=\"40\" RIGHTMARGIN=\"40\" \076",$couleur_fond);
        if($site eq "") # <edition_du_lien_sommaire>(: si publication sur un site on n'dite pas le lien vers le sommaire)
         {
          $szSHTM .= sprintf("\n\074DIV ALIGN=left\076\074A HREF=\"%s%s\"\076%s\074/A\076\074/DIV\076\n",$protocole,$ficin,"__");
          $szSHTM .= sprintf("\074DIV ALIGN=right\076\074A HREF=\"%s%s#%s\"\076%s\074/A\076\074/DIV\076\n",$protocole,$ficlien,$ref,$refTitle);
         }
				else
				 {
          $protocole = "http://";  # lien protocole https
          $szSHTM .= sprintf("\074DIV ALIGN=right\076\074A HREF=\"%s%s\"\076%s\074/A\076\074/DIV\076\n",$protocole,$site,$param{"LIB_RET_ACC"});
				 }
        $date_src = substr(util::dcf($ficin),0,8);
        $szSHTM .= sprintf("\074DIV ALIGN=right\076\ %s %s\074/DIV\076\n",$param{"P_CREE"},$date_src);
        $date_src = substr(util::dmf($ficin),0,8);
        $szSHTM .= sprintf("\074DIV ALIGN=right\076\ %s %s\074/DIV\076\n",$param{"P_MAJ"},$date_src);
        $szSHTM .= sprintf("\074DIV ALIGN=right\076\ %s %s\074/DIV\076\n",$param{"P_GEN"},$date_jour);
       }
      else # <rfrence_extrapage>(: ouverture d'un nouvel onglet par "target" )
       {
        $szSHTM .= sprintf("\074A %s HREF=\"%s%s#%s\"\076%s\074/A\076",$param{"MOD_NAV"},$protocole,$ficlien,$ref,$refTitle);
        $liste_lien{$ficlien}="\n"; # constitution de la liste des rfrences de la page
       }
     }
    if($trt == -1 ) { $trt = 1;} # cas inline_html (on restaure la valeur antrieure:  priori hors commentaire)
    $ref = ""; $refTitle = "";
   }
  elsif($separ eq "_" ) #<cas_underscore>()
   {
    if ($nivBloc[$iBra] == 1) 
     { 
       $tag .=$mot.$e_separ; 
       $sepmot = "&nbsp;";
       if($mot eq "l" or $mot eq "d") { $sepmot ="'";}
       #<traitement_des_prefixes_d_etiquette>()
       if( index("\074_\076",$p_separ) != -1 && ($lib_infixe=$infixe_liste{$mot}) ne "")
        {
         $tagTitle =$lib_infixe." ".$tagTitle.$sepmot;
        }
       else
        {
         $tagTitle .=$mot.$sepmot;
        }
     }
    elsif ($nivBloc[$iCro] == 1) 
     { 
      $ref .=$mot.$e_separ;
      $sepmot = "&nbsp;";
      if($mot eq "l") { $sepmot ="'";}
      $refTitle .=$mot.$sepmot;
     }
    elsif ($nivBloc[$iPar] == 1 && $iCom >= 3) 
     {
      $comMent .=$mot.$e_separ;
     }
    else 
     {
      $szSHTM .= sprintf("%s%s",$mot,$e_separ);
     }
   }
  elsif($separ eq "(") # <cas_parenthese_ouvrante>(:[traitement_d_une_parenthese])
   {
    $nivBloc[$iPar]++;
    if($mot ne "") {$szSHTM .= sprintf("%s",$mot);}
    if($p_separ eq "]" && $pMot eq "som" && $nivBloc[$iAcc] == 0 && $iStep == 0 ) # [dtection_du_titre_de_la_page]
     {
      $iStep = 1;
     }
    if($iCom < 3 && $p_separ eq "\076" && ($pBSepar eq "\076" || ($p2BSepar eq "\076" && $pBSepar eq "]") || $iStep == 1) )
    #if($iCom < 3 && ($pSepar eq "\076" || $iStep == 1) )
     {
      $iCom = 1; # [commentaire_mentor_html_spe]
     }
    elsif($iCom >= 3)
     {
      # on edite pas le sparateur
     }
    elsif($s_separ eq "*" && $s_mot eq "")
     {
      $szSHTM .= sprintf("\074font color=\"#990000\"\076\074B\076\074I\076Nouveau:\074/I\076\074/B\076\074/font\076\074BR\076");
     }
    elsif($s_separ eq "" && $s_mot eq "")
     {
      $szSHTM .= sprintf("\074font color=\"#999999\"\076\074B\076\074I\076Obsolte:\074/I\076\074/B\076\074/font\076\074BR\076");
     }
    elsif($s_separ eq "!" && $s_mot eq "")
     {
      $szSHTM .= sprintf(" ");
     }
    elsif($s_separ eq "#" && $s_mot eq "")
     {
      $szSHTM .= sprintf("");
     }
    else
     { 
      $szSHTM .= sprintf("%s",$e_separ);
     }
   }
  elsif($separ eq ")") # <cas_parenthese_fermante>(:[traitement_d_une_parenthese])
   {
    my $imgLarg == "";
    my $imgHaut == "";

    $comMent .= $mot; # dernier mot du commentaire mentor
    if( $iCom >= 3 && $iCom < 7) # <traitement_d_un_alias_url> voir aussi [GetPathLien]
     {
      if( $iCom == 5 ) # <traitement_d_une_image> option taille de l'image [balise_image]
       {
        my $imgPos;
        my $imgUnc;
        my $imgSepar;
        my $imgpSepar;
        $imgPos=sam::MotSuivant(\$comMent,\$imgUnc,",()",\$imgSepar,\$imgpSepar); # 
        $imgUnc =~ s/BASE%/$base/; # <gestion_de_la_variable_d_environnement_base_mentor>()
        if($imgSepar eq ",") # une taille est dfinie
         {
          $imgPos=sam::MotSuivant(\$comMent,\$imgLarg,",",\$imgSepar,\$imgpSepar); # 
          $imgPos=sam::MotSuivant(\$comMent,\$imgHaut,",",\$imgSepar,\$imgpSepar); # 
         }
         $comMent = $imgUnc; # le chemin de l'image seul sans les attributs de taille
        $liste_image{$imgUnc}="\n"; # constitution de la liste des images de la page
       }
      my $raclien=substr($comMent,0,2);
      my $szURL=util::trim($alias_liste{lc($raclien)});
      if( $szURL ne "")
       {
        $szURL =~ s/\\\\/\\/g;
        $comMent =$szURL.substr($comMent,2);
       }
     }
    if($nivBloc[$iAcc] == 0 && $iStep == 1) # fin du titre cf [dtection_du_titre]
     {
      $iStep = 2;
      # couleur de fond gainsboro DCDCDC
      $szSHTM .= sprintf("\n\074HEAD\076\n\074TITLE\076%s\074/TITLE\076\n\074/HEAD\076\n",$comMent);
      $szSHTM .= sprintf("\074BODY BGCOLOR=\"%s\" TOPMARGIN=\"50\" BOTTOMMARGIN=\"50\" LEFTMARGIN=\"40\" RIGHTMARGIN=\"40\" \076",$couleur_fond);
      
      $szSHTM .= sprintf("\074FONT FACE=\"ARIAL\"SIZE=%d\076\n",$szT);
      #<insertion_d_un_logo_du_fichier>()
      if($param{"LOGO_PATH"})
       {
        $szSHTM .= sprintf("\074IMG SRC=\"FILE://%s%s\" ALIGN=\"RIGHT\" VSPACE=\"10\" ALT=\"\" \076\n",$ficvol,$param{"LOGO_PATH"});
       } 
      $ficlien=&GetPathLien($ref);
      $szSHTM .= sprintf("\074DIV ALIGN=right\076\074A HREF=\"FILE://%s#%s\"\076%s\074/A\076\074/DIV\076\n",$ficlien,$ref,$refTitle);
      &printTag($szTiT-$nivBloc[$iAcc],$tag,$comMent,1,$bNumer);$bNumer = 0;
     }
    elsif( $iCom == 2 && $tag ne "" ) # <edition_d_une_etiquette_avec_etiquette_plus_commentaire>()
     {
      &printTag($szTiT-$nivBloc[$iAcc],$tag,$tagTitle.$comMent,0,$bNumer);$bNumer = 0;
     }
    elsif( $iCom == 1 && $comMent ne "" ) # <edition_d_une_etiquette_avec_commentaire_seul>()
     {
      &printTag($szTiT-$nivBloc[$iAcc],$tag,$comMent,0,$bNumer);$bNumer = 0;
     }
    elsif( $iCom == 1 && $tag ne "" ) # <edition_d_une_etiquette_avec_commentaire_vide>()
     {
      &printTag($szTiT-$nivBloc[$iAcc],$tag,$tagTitle,0,$bNumer);$bNumer = 0;
     }
    elsif( $iCom == 5 ) # <edition_d_une_image>()
     {
      if($site ne "")
       {
        my $filepath_tag=$comMent;
        my $ext;
        my $file;
        my $path;
        util::basename($filepath_tag,\$path,\$file,\$ext);
        $comMent = $file.".".$ext;
        $protocole = "";
       }
      if($imgLarg eq "")
       {
        $szSHTM .= sprintf("\074IMG SRC=\"%s%s\"\076\074/A\076",$protocole,$comMent);
       }
      else
       {
        $szSHTM .= sprintf("\074IMG SRC=\"%s%s\" width=\"%s\" height= \"%s\" \076\074/A\076",$protocole,$comMent,$imgLarg,$imgHaut);
       }
     }
    elsif( $iCom >= 3 && $iCom < 7) # <edition_d_un_lien_html_spcifi>()
     {
      if($site ne "" && $iCom == 4 ) # <edition_d_un_lien_file>(: si publication sur un site le lien file devient un http sur le rpertoire local)
       {
        my $filepath_tag=$comMent;
        my $ext;
        my $file;
        my $path;
        util::basename($filepath_tag,\$path,\$file,\$ext);
        $comMent = $file.".".$ext;
        $protocole = "";
       }
       else # en local (FILE) on traduit la variable d'environnement BASE
       {
        $comMent =~ s/%BASE%/$base/;
       }
      $szSHTM .= sprintf("\074A %s HREF=\"%s%s\"\076%s\074/A\076",$attribut,$protocole,$comMent,$tag);
     }
    elsif( $iCom == 7 ) # <edition_d_un_email>()
     {
      $szSHTM .= sprintf("\074A HREF=\"%s:%s\"\076%s\074/A\076",$protocole,$comMent,$tag);
     }
    elsif( $iCom == 8 ) # <edition_du_son_de_fond>()
     {
      $szSHTM .= sprintf("\074BGSOUND SRC=\"%s\"\076",$comMent);
     }
    else # il ne s'agit pas d'une tiquette mais d'une mise entre parenthse normale du texte
     {
      if($typAff[$nivBloc[$iPar]] eq "*" || $typAff[$nivBloc[$iPar]] eq "\%" || $typAff[$nivBloc[$iPar]] eq "") # <fin_nouveau_texte>()
       {
        if($typBloc[$nivBloc[$iAcc]] ne ";" ) # hors d'un tableau
         {
          $szSHTM .= sprintf("\074/font\076");
         }
        else
         {
          $ppR="";
          if($s_separ eq "\n") { $s_separ = "";}
         }
        $szSHTM .= sprintf("%s",$mot);
       }
      if($typAff[$nivBloc[$iPar]] eq "#") # <fin_couleur>()
       {
        $szSHTM .= sprintf("%s",$mot);
        if($typBloc[$nivBloc[$iAcc]] ne ";" ) # hors d'un tableau
         {
          $szSHTM .= sprintf("\074/font\076");
         }
        else
         {
          $ppR="";
          if($s_separ eq "\n") { $s_separ = "";}
         }
       }
      elsif($typAff[$nivBloc[$iPar]] eq "!") # <fin_texte_gras>()
       {
        $szSHTM .= sprintf("%s",$mot);
        $szSHTM .= sprintf("\074/B\076");
       }
      else
       {
        $szSHTM .= sprintf("%s%s",$mot,$e_separ);
       }
     }
    $tag = ""; $tagTitle = ""; $comMent = "";  $iCom = 0;# reinitialisation du commentaire mentor
    $typAff[$nivBloc[$iPar]] = ""; # r-initialisation du type du bloc parenthse (affichage) finissant
    $nivBloc[$iPar]--;
    if($nivBloc[$iPar] < 0) { $nivBloc[$iPar] = 0;} # erreur si dcrment en dessous de zro
   }
  else #}{autres cas de traitement exclusif : le elsif a t interrompu ici pour la gestion de la prservation de la forme des sources
   {
    if($mot eq "" && $pMot eq "" && $separ eq "-"   # <cas_tiret>(:traitement des puces)
          && ($p_separ eq " " || $p_separ eq "\t" )  
          && $typBloc[$nivBloc[$iAcc]] ne "=" && $typBloc[$nivBloc[$iAcc]] ne ";") 
     {
      $szSHTM .= sprintf("\n\074LI\076");
      $p2BSepar = ""; $pBSepar = "";
     }
    elsif($separ eq "\n" ) # <cas_sauts_de_lignes>()
     {
      if($mot eq "" && $p_separ eq "\n") # si ligne vide edition d'un paragraphe
       {
        $szSHTM .= sprintf("\074P\076\n");
       }
      elsif($mot eq "" && index($sepBloc,$p_separ) != -1 ) # si saut de ligne aprs un sparateur de bloc
       {
        $szSHTM .= sprintf("\n");
        $tagTitle =""; # <cas_etiquette_sans_commentaire_en_fin_de_ligne>(tiquette invisible pour le HTML)
       }
      else
       {
        $szSHTM .= sprintf("%s%s",$mot,$e_separ);
       }
     }
    elsif($separ eq "\173") # <cas_accolade_ouvrante>(:[traitement_d_une_accolade])
     {
      $nivBloc[$iAcc]++;
      $szSHTM .= sprintf("%s",$mot);
      if( not ($s_separ eq "-" and $s_mot eq "") ) # les blocs de type puce sont trop espacs
        {
        $szSHTM .= sprintf("\074P\076");
        }
      $bNumer = 1;
      if($nivBloc[$iAcc] == 1 ) # <premier_bloc_bloc_principal_police_par_defaut>()
       {
        $szSHTM .= sprintf("\074FONT FACE=\"%s\"SIZE=%d\076\n",$szFont,4);
       }
      if( $indEdFinTab == 0 and $s_mot eq "" and ( $s_separ eq "#" or $s_separ eq "&" ) and $typBloc[$nivBloc[$iAcc]-1] eq ";") # <cas_fin_tableau_csv>() [fin_tableau_csv] pour finir le tableau aprs les bloc d'dition gnr par [CSV_EDT]
       {
        $indEdFinTab = 1;
        $szSHTM .= sprintf("\074/table\076");
        $szSHTM .= sprintf("\074/FONT\076");
        $szSHTM .= sprintf("\074P\076");
        $szTdAttr = "";
        $typBloc[$nivBloc[$iAcc]] = ""; # pour ne pas fermer le tableau deux fois cf [fin_tableau_csv]
       }
     }
    elsif($separ eq "\175") # <cas_accolade_fermante>(:[traitement_d_une_accolade])
     {
		  $lang=""; # [llea_tec] fin du bloc [llea] si prsent
      if($typBloc[$nivBloc[$iAcc]] eq "_") # <fin_commentaire_html>()
       {
        $szSHTM .= sprintf("---\076"); $iComHTML--;$trt = 1;
       }
      elsif($typBloc[$nivBloc[$iAcc]] eq "@") # <fin_inside_html>()
       {
        $trt = 1;
       }
      elsif($indEdFinTab == 0 and $typBloc[$nivBloc[$iAcc]] eq ";") # <fin_tableau_csv>()
       {
        $indEdFinTab = 1;
        $szSHTM .= sprintf("\074/table\076");
        $szSHTM .= sprintf("\074/FONT\076");
        $szSHTM .= sprintf("\074P\076");
        $szTdAttr = "";
       }
      elsif($typBloc[$nivBloc[$iAcc]] eq "-") # <fin_puces>()
       {
        $szSHTM .= sprintf("\074/UL\076");
       }
      elsif($typBloc[$nivBloc[$iAcc]] eq "`") # <fin_puces_numrotes>()
       {
        $szSHTM .= sprintf("\074/OL\076");
       }
      elsif($typBloc[$nivBloc[$iAcc]] eq "=" && $iPre != 3) # <fin_cas_preservation_forme_du_texte>()
       {
        $szSHTM .= sprintf("\074/FONT\076\074/PRE\076");
        $iPre=0;
       }
      elsif($typBloc[$nivBloc[$iAcc]] eq "" && $iPre != 3) # <fin_cas_preservation_forme_du_texte_police_proportionnelle>()
       {
        $szSHTM .= sprintf("\074/FONT\076\074/PRE\076");
        $szSHTM .= sprintf("\074/B\076");
        $iPre=0;
       }
      elsif($typBloc[$nivBloc[$iAcc]] eq "") # <fin_cas_lecture_convergente>()
       {
        # deuxime colonne
        $szConverge = $szSHTM; # contenu du bloc convergent 
        $szSHTM .= sprintf("\074/td\076\074td\076");
        $szSHTM .= sprintf("%s",$szConverge);
        $szSHTM .= sprintf("\074/tr\076");
        # fin tableau
        $szSHTM .= sprintf("\074/table\076");
        $szSHTM .= sprintf("\074/FONT\076");
        $szSHTM .= sprintf("\074P\076");
        printf(SHTM $szSHTM); $szSHTM = ""; 
       }
      else
       {
        $szSHTM .= sprintf("%s\074P\076",$mot);
        if($nivBloc[$iAcc] == 1) # <fin_premier_bloc_bloc_principal_police_par_defaut>()
         {
          $szSHTM .= sprintf("\074/font\076");
         }
       }
      if($typBloc[$nivBloc[$iAcc]] eq ";") { $nivBlocCsv--;}
      $typBloc[$nivBloc[$iAcc]] = ""; # r-initialisation du type du bloc finissant
      $nivBloc[$iAcc]--;
      if($nivBloc[$iAcc] < 0) { $nivBloc[$iAcc] = 0;} # erreur si dcrment en dessous de zro
      if($typBloc[$nivBloc[$iAcc]] eq "=") { next;} # [cas_preservation_forme_du_texte]
     }
    else # <cas_gnral>(: lecture d'un mot sans dtection de contexte particulier)
     {
      if( $p_separ eq "\076" && $tag ne "" ) # <edition_d_une_etiquette_sans_commentaire>()
       {
        &printTag($szT,$tag,$tagTitle,0,0);
        $szSHTM .= sprintf("%s%s",$mot,$e_separ);
       }
      if($iCom) # <stockage_du_commentaire_mentor>()
       {
        $comMent .=$mot.$e_separ;
       }
      else
       {
        if($bGras ==1)
         {
          $szSHTM .= sprintf("\n\074B\076\074U\076%s%s\074/U\076\074/B\076",$mot,$e_separ); # le \n est la en [cas_preservation_forme_du_texte]
         }
         else # edition du mot lu cas gnral
         {
					if($lang eq "")
					 {
            $szSHTM .= sprintf("%s%s",$mot,$e_separ);
				   }
					else
					 {
						my $mot_etr = lc($mot);
						my $mot_tra = $dico_liste{$mot_etr};
						#<conjugaison_raf_img>(g:\mt\fic\gif\underconst.gif) analyser le problme de la conjugaison des verbes (solution diffrente pour les langues). 
  					if($mot_tra eq "" && substr($mot_etr,-1) eq "s") # gestion du pluriel dans le dictionnaire
						 {
							my $mot_sing = substr($mot_etr,0,-1);
						  $mot_tra = $dico_liste{$mot_sing};
						 }
  					if($mot_tra eq "" && substr($mot_etr,-2) eq "es") # gestion du pluriel dans le dictionnaire
						 {
							my $mot_sing = substr($mot_etr,0,-2);
						  $mot_tra = $dico_liste{$mot_sing};
						 }
						if($mot_tra ne "")
						 {
						  $szSHTM .= sprintf("\n\074abbr title=\042%s\042\076%s%s\074/abbr\076",$mot_tra,$mot_etr,$e_separ); # le \n est la en [cas_preservation_forme_du_texte]
						 }
						else
						 {
							$szSHTM .= sprintf("%s%s",$mot,$e_separ);
						 }
				   }
         }
       }
     }
    if($typBloc[$nivBloc[$iAcc]] ne "" ) # hors d'un bloc [cas_lecture_convergente]
     {
      printf(SHTM $szSHTM); $szSHTM = ""; 
     }
   }
#} fin autres cas de traitement exclusif
#} fin cas de traitement exclusif
 }
#<edition_en_commentaire_de_la_liste_des_liens_de_la_page>()
$szSHTM .= sprintf("\n\074P\076\n\074!---\nliste des rfrences fichiers de la page\n{\n");
      printf(SHTM $szSHTM); $szSHTM = ""; 
print SHTM %liste_lien;
print SHTM %liste_image;
$szSHTM .= sprintf("}\n---\076");

$szSHTM .= sprintf("\n\074/FONT\076\074/BODY\076\n\074/HTML\076\n");
      printf(SHTM $szSHTM); $szSHTM = ""; 
close SHTM;
}
if($cheminBatch ne "") 
{ 
 close SBATCH;
}
if($debug) { close SLOG;}
close fsource;
close fextensio;
close futags;
close finfixe_liste;
close falias_liste;
