#<sam_pm>(syntax analysis manager)[sam_pm_som]
#  12/01/2005 FP creation par modularisation de la fonction MotSuivant
#                en faire un objet
#  02/11/2006 FP la fonction San oeuvrant sur un fichier: lecture des blancs successifs en un seul appel
package sam;
#use strict;

BEGIN {
}
END {
}

my $debug=0;

my $sCar; # caractre suivant pour San
my $Offset=0; # <Offset> variable de module changeant le fonctionnement de la fonction MotSuivant cf commentaire entte de [MotSuivant] 

#<MotSuivant>( fonction d' analyse d'un texte transmis sous forme d'une chane de caractre)
#<MotSuivant_pl> portage de [MotSuivant_bas]
#
# arguments:
# le_texte:  texte  analyser
# le_mot: mot trouv
# separateurs: liste des sparateurs possibles
# separ:  separateur trouv pour le mot
# prec_separ : separateur de mot de la dernire itration ( partir du sparateur pass en paramtre)
#
# retour: entier, taille du texte restant  traiter
#
#  20/01/2012 FP introduction de la lecture par offset, par une variable de module  positionner pour ne pas alourdir la fonction ni l'interface.
#                le nombre de caractres  lire est plac dans la chane des sparateurs qui changent de sens pour cette utilisation.
#                une faon de faire serait de tester la numricit de cette chane pour savoir que l'on est en mode offset mais
#                ce test est jug trop lourd car il appelle une fonction.
#
sub MotSuivant
{
 # arguments
 my $le_texte = shift; # rference sur le texte  lire (le texte est modifi dans la fonction : on avance dans la lecture
 my $le_mot = shift; # le mot lu
 my $separateurs = shift; # la liste des sparateurs de mots
 my $le_separ = shift; # rfrence sur le sparateur rencontr qui termine le mot
 my $prec_separ = shift; # rfrence sur le sparateur prcdent (pas utilis ?)
 # variable locale
 my $retour = 0; # retour de la fonction : longueur du texte restant  lire
 my $sep; # String sparateur lu
 my $pos; # Integer position de lecture
 my $fini; # Boolean indicateur de fin de lecture
 my $taille; # Integer taille initiale du texte  lire

 $fini = 0;
 $pos = -1;
 $taille = length(${$le_texte});
 ${$le_mot} = "";
	
 ${$prec_separ} = ${$le_separ}; # alimentation du sparateur prcdent

 if( $taille != 0  && $Offset == 0)
	{
	 do
		{
		 $pos = $pos + 1;
		 $sep = substr(${$le_texte}, $pos, 1); # on lit un caractre
		 if(index($separateurs, $sep) > -1)    # si c'est un sparateur on a fini de lire le mot ventuellement vide
			{
			 ${$le_separ} = $sep;
			 if($sep eq "")
				{
				 $pos = $pos - 1;
				}
			 ${$le_texte} = substr(${$le_texte}, $pos + 1, $taille - $pos);  # on dcale le texte de l'avance de lecture
			 $retour = length(${$le_texte});
			 $fini = 1;
			}
		 else # sinon on ajoute le caractre au mot
			{
			 ${$le_mot} = ${$le_mot}.$sep;
			}
		}
	 while ($fini == 0)
	}
 elsif( $taille != 0  && $Offset != 0)
	{
	 ${$le_mot} = substr(${$le_texte},0,$separateurs);
	 ${$le_texte} = substr(${$le_texte}, $separateurs + 1, $taille - $separateurs);
	}

 if($debug > 4) { printf("mot|%s|separ|%s|\n",${$le_mot},${$le_separ});}

 return $retour;
}
#<San>(analyseur syntaxique travaille sur un descripteur de fichier)
sub San
{
 # arguments
 my $mot = shift; # 
 my $separateurs = shift; # 
 my $delimiteurs = shift; # 
 my $separ = shift; # 
 my $fhin = shift; # file handle de lecture

 if(!$fhin)
  {
	 $fhin = \*STDIN;
  }
 # variable locale
 my $retour; # 
 my $sep; # 
 my $pos; # 
 my $fini; #
 my $car; # 
 my $deli; #

 while ( ($car = getc($fhin)) ne "")
 {
  if( ($pos=index($delimiteurs, $car)) > -1 or $deli != 0 ) # c'est un dlimiteur
   {
    if( $pos != 0) { $deli = $pos;} # un dlimiteur de chaine est trouv
    elsif( substr($delimiteurs,$deli+1,1) eq $car) { $deli = 0;} # on trouve sa correspondance
    else { ${$mot} = ${$mot}.$car;}
    next;
   }
  elsif(index($separateurs, $car) > -1) # c'est un sparateur: fin du mot
   { 
    ${$separ} = $car; last; 
   }
  else # a fait partie du mot
   {
    ${$mot} = ${$mot}.$car;
   }
 }
 return $car;
}
#<sam_pm_fin>(fin du script perl)
1;
