#<util_pm>(fonction utilitaire perl )[util_pm_som]
#  10/01/2022 FXP fonction nui

package util;
use strict;

use sam;

my $nbsj =86400; #<nbsj>(nombre de seconde dans une journe) 
my $pi_r=3.1415926535897936; #<pi_r>(en radian) 

BEGIN {
}
END {
}
#<basename_pl>(: extraction du nom de base d'un chemin de fichier - identique  la fonction unix )
sub basename {
 $_=shift;
 my $basepath=shift;
 my $basefile=shift;
 my $baseext=shift;
 my $finpath=rindex($_,"/");
 ${$basepath}=substr($_,0,$finpath);
 my $basename=substr($_,$finpath+1);
 my $debext=rindex($basename,".");
 ${$basefile}=substr($basename,0,$debext);
 ${$baseext}=substr($basename,$debext+1);
 $_=$basename;
 return $_;
}
#<isnum>(: teste la numricit d'une chane)
sub isnum
{
 $_=shift;
if($_ eq "")
 { return 0; }
elsif( tr/[0-9]\.// == length($_))
 { return 1; }
else 
 { return 0; }
}
#<trim>() dupliqu dans [traite_csv_pm] pour des raisons de performance et plus tard pour ne pas prendre en compte les NBSP
sub trim {
 $_=shift;
 tr/\n/ /;
 tr/\n//;
 s/^\s+//;
 s/\s+$//;
 s/^+//;
 s/+$//;
 $_;
}
#<DateJour>()
sub DateJour 
{
 my $fmtDate=shift;
 my $offsetDate=shift;

 my $szDate; # format chane date de sortie
 my $sec;
 my $min;
 my $heure;
 my $mjour;
 my $mois;
 my $annee;
 my $sjour;
 my $ajour;
 my $isdst;

 my @mois_abbr = qw(Jan Fv Mar Avr Mai Jui Jui Ao Sep Oct Nov Dc);
 my $nDate = time() + $offsetDate * $nbsj;
 my $szDateUS = localtime($nDate);
 ($sec,$min,$heure,$mjour,$mois,$annee,$sjour,$ajour,$isdst) = localtime($nDate);
 my $szMois=$mois_abbr[$mois];
 if($fmtDate eq "" || $fmtDate eq "amj_hms" )
	{
	 $szDate=sprintf("%04d%02d%02d_%02d%02d%02d",$annee+1900,$mois+1,$mjour,$heure,$min,$sec);
	}
 elsif($fmtDate eq "" || $fmtDate eq "amjhms" )
	{
	 $szDate=sprintf("%04d%02d%02d%02d%02d%02d",$annee+1900,$mois+1,$mjour,$heure,$min,$sec);
	}
 elsif($fmtDate eq "" || $fmtDate eq "hms" )
	{
	 $szDate=sprintf("%02d:%02d:%02d",$heure,$min,$sec);
	}
 elsif($fmtDate eq "" || $fmtDate eq "hm" )
	{
	 $szDate=sprintf("%02dh%02d",$heure,$min);
	}
 elsif($fmtDate eq "" || $fmtDate eq "amj_hm" )
	{
	 $szDate=sprintf("%04d%02d%02d_%02d%02d",$annee+1900,$mois+1,$mjour,$heure,$min);
	}
 elsif($fmtDate eq "" || $fmtDate eq "amj_h" )
	{
	 $szDate=sprintf("%04d%02d%02d_%02d",$annee+1900,$mois+1,$mjour,$heure);
	}
 elsif($fmtDate eq "amj")
	{
	 $szDate=sprintf("%04d%02d%02d",$annee+1900,$mois+1,$mjour);
	}
 elsif($fmtDate eq "am")
	{
	 $szDate=sprintf("%04d%02d",$annee+1900,$mois+1);
	}
 elsif($fmtDate eq "j")
	{
	 $szDate=sprintf("%02d",$mjour);
	}
 elsif($fmtDate eq "m")
	{
	 $szDate=sprintf("%02d",$mois+1);
	}
 elsif($fmtDate eq "a")
	{
	 $szDate=sprintf("%04d",$annee+1900);
	}
 elsif($fmtDate eq "jma/")
	{
	 $szDate=sprintf("%02d/%02d/%04d",$mjour,$mois+1,$annee+1900);
	}
 elsif($fmtDate eq "jmA/")
	{
	 $szDate=sprintf("%02d/%02d/%02d",$mjour,$mois+1,$annee-100);
	}
 elsif($fmtDate eq "jma-")
	{
	 $szDate=sprintf("%02d-%02d-%04d",$mjour,$mois+1,$annee+1900);
	}
 elsif($fmtDate eq "amj-")
	{
	 $szDate=sprintf("%04d-%02d-%02d",$annee+1900,$mois+1,$mjour);
	}
 elsif($fmtDate eq "jma,")
	{
	 $szDate=sprintf("%02d,%02d,%04d",$mjour,$mois+1,$annee+1900);
	}
 elsif($fmtDate eq "js")
	{
	 $szDate=sprintf("%s",$sjour);
	}
 return $szDate;
}
#<nui>(norme UTF-8 vers iso 8859 latin 1) DEBUG : ne fonctionne pas
sub nui 
{
 my $szChaine=shift;
 if($szChaine ne "")
	{
	 $szChaine =~ s/œ/oe/g;
	 $szChaine =~ s/Ê//g;
	 $szChaine =~ s/È//g;
	 $szChaine =~ s/Â//g;
	 $szChaine =~ s/é//g;
	 $szChaine =~ s/À//g;
	 $szChaine =~ s/è//g;
	 $szChaine =~ s/à//g;
	 $szChaine =~ s/É//g;
	 $szChaine =~ s/ç//g;
	 $szChaine =~ s/ê//g;
	 $szChaine =~ s/ô//g;
	 $szChaine =~ s/î//g;
	 $szChaine =~ s/ÿ//g;
	 $szChaine =~ s/û//g;
	 $szChaine =~ s/ü//g;
	 $szChaine =~ s/ï//g;
	 $szChaine =~ s/â//g;
	 $szChaine =~ s/Ó//g;
	 $szChaine =~ s/ù//g;
	 $szChaine =~ s/’/\047/g;
	 $szChaine =~ s/‘/\047/g;
	 $szChaine =~ s/« //g;
	 $szChaine =~ s/»//g;
	 $szChaine =~ s/ël//g;
	 $szChaine =~ s/—/-/g;
	 $szChaine =~ s/– //g;
	 $szChaine =~ s/“/"/g;
	 $szChaine =~ s/”/"/g;
	 $szChaine =~ s/􀂑/"/g;
	 $szChaine =~ s/Í//g;
	 $szChaine =~ s/ó//;
	 $szChaine =~ s/á//g;
	 $szChaine =~ s/Á//g;
	 $szChaine =~ s/í//g;
	 $szChaine =~ s/ñ//g;
	 $szChaine =~ s/ú//g;
	 $szChaine =~ s/…/.../g;
	 $szChaine =~ s/¿//g;
	 $szChaine =~ s/ / /g;
	 $szChaine =~ s/«/ /g;
	}
 return $szChaine;
}
#<nai>(norme ascii vers iso 8859 latin 1)
sub nai 
{
 my $szChaine=shift;
 if($szChaine ne "")
	{
	 $szChaine =~ s///g;
	 $szChaine =~ s///g;
	 $szChaine =~ s///g;
	 $szChaine =~ s///g;
	 $szChaine =~ s///g;
	 $szChaine =~ s///g;
	 $szChaine =~ s///g;
	 $szChaine =~ s///g;
	 $szChaine =~ s///g;
	 $szChaine =~ s///g;
	 $szChaine =~ s///g;
	 $szChaine =~ s///g;
	 $szChaine =~ s///g;
	 $szChaine =~ s///g;
	 $szChaine =~ s///g;
	 $szChaine =~ s///g;
	 $szChaine =~ s///g;
	 $szChaine =~ s//_/g;
	 $szChaine =~ s//oe/g;
	 $szChaine =~ s///g;
	 $szChaine =~ s// /g;
	}
 return $szChaine;
}
#<nan>(suppression des caractres non alphanumeriques )
sub nan
{
 my $szChaine=shift;
 if($szChaine ne "")
	{
	 #$szChaine =~ s/[&~"#'{}=()\[\]+-|`_\^@$%!:;,?.\/]/ /g;
	 $szChaine =~ s/[+-_%!:;,?]/_/g;
   #$szChaine =~ s/[,;:.]/ /g;
	}
 return $szChaine;
}
#<nan>( )
sub nan
{
 my $szChaine=shift;
 if($szChaine ne "")
	{
   $szChaine = &trim($szChaine);
   $szChaine =~ s/[-+= '''&(),?;:]/ /g;
   $szChaine =~ s/\[/ /g;
   $szChaine =~ s/\]/ /g;
   $szChaine =~ s/\(/ /g;
   $szChaine =~ s/\)/ /g;
   $szChaine =~ s/>/ /g;
   $szChaine =~ s/</ /g;
   $szChaine =~ s/!/ /g;
   $szChaine =~ s/__/ /g;
   $szChaine =~ s/ $//g;
   $szChaine =~ s/  / /g;
   $szChaine =~ s/^ //g;
   $szChaine =~ s/\\ /\\/g;
   $szChaine =~ s/\./ /g; 
	}
 return $szChaine;
}
#<nac>(non accentu, suppression des accents)
sub nac 
{
 my $szChaine=shift;
 if($szChaine ne "")
	{
   $szChaine =~ s/[]/e/g;
   $szChaine =~ s/[]/e/g;
   $szChaine =~ s/[]/a/g;
   $szChaine =~ s/[]/A/g;
   $szChaine =~ s//ae/g;
   $szChaine =~ s//AE/g;
   $szChaine =~ s//c/g;
   $szChaine =~ s//C/g;
   $szChaine =~ s//D/g;
   $szChaine =~ s//N/g;
   $szChaine =~ s//n/g;
   $szChaine =~ s/[]/y/g;
   $szChaine =~ s//Y/g;
   $szChaine =~ s/[]/i/g;
   $szChaine =~ s/[]/I/g;
   $szChaine =~ s/[]/o/g;
   $szChaine =~ s/[]/o/g;
   $szChaine =~ s/[]/u/g;
   $szChaine =~ s/[]/U/g;
	 # caractres ascii 8 bits
	 $szChaine =~ s/[]/e/g;
	 $szChaine =~ s//E/g;
	 $szChaine =~ s/[.]/a/g;
	 $szChaine =~ s//c/g;
	 $szChaine =~ s/[]/i/g;
	 $szChaine =~ s/[""]/o/g;
	 $szChaine =~ s/[]/u/g;
	 $szChaine =~ s//A/g;
	}
 return $szChaine;
}
#<nnf>(normalisation nom fichier) [fonction_normalisation_nom_fichier]
sub nnf 
{
 my $szChaine=shift;
 if($szChaine ne "")
	{
   $szChaine = &trim($szChaine);
	 #$szChaine = &nai($szChaine);
	 #$szChaine = &nac($szChaine);
   $szChaine =~ s//E/g;
	 $szChaine =~ s//a/g;
	 $szChaine =~ s/[-+= ''&(),?;,]/_/g;  # le caractre ":" est absent car il intervient dans les noms de fichier !
   $szChaine =~ s/\256/_/g;
   $szChaine =~ s/\201/E/g;
   $szChaine =~ s/\[/_/g;
   $szChaine =~ s/\]/_/g;
   $szChaine =~ s/\(/_/g;
   $szChaine =~ s/\)/_/g;
   $szChaine =~ s/\{/_/g;
   $szChaine =~ s/\}/_/g;
   $szChaine =~ s/"/_/g;
   $szChaine =~ s/!/_/g;
   $szChaine =~ s/__/_/g;
   $szChaine =~ s/_$//g;
   $szChaine =~ s/__/_/g;
   $szChaine =~ s/^_//g;
   $szChaine =~ s/\\_/\\/g;
   $szChaine =~ s/_\././g; # remplacement de _. par .
   $szChaine =~ s/\(.*\)\(\.\)\(.*\)\(\..*\)/\1_\3\4/g; # remplacement de _. par .
   $szChaine =~ s/(.*)(\.)(.*)(\..*)/\1_\3\4/g; # remplacement des points par _ sauf le dernier (extension du fichier)
   $szChaine =~ s/(.*)(\.)(.*)(\..*)/\1_\3\4/g;
   $szChaine =~ s/(.*)(\.)(.*)(\..*)/\1_\3\4/g;
   $szChaine =~ s/(.*)(\.)(.*)(\..*)/\1_\3\4/g;
   $szChaine =~ s/(.*)(\.)(.*)(\..*)/\1_\3\4/g;
   $szChaine =~ s/__/_/g;
   $szChaine =~ s/__/_/g;
   $szChaine =~ s/__/_/g;
   $szChaine =~ s/_>/>/g;
   $szChaine =~ s/<_/</g;
	}
 return $szChaine;
}
#<nnd>(normalisation nom repertoire - directory) [fonction_normalisation_nom_tag]
sub nnd 
{
 my $szChaine=shift;
 if($szChaine ne "")
	{
   $szChaine = &nnf($szChaine);
   $szChaine =~ s/[.]/_/g;  # le caractre ":" est absent car il intervient dans les noms de fichier !
   $szChaine =~ s/[-+= ''&(),?;]/_/g;  # le caractre ":" est absent car il intervient dans les noms de rpertoire !
	}
 return $szChaine;
}
#<nnt>(normalisation nom tag) [fonction_normalisation_nom_tag]
sub nnt 
{
 my $szChaine=shift;
 if($szChaine ne "")
	{
	 $szChaine = &nnf($szChaine);
   $szChaine =~ s/[.]/_/g; 
	 $szChaine =~ s/[-+= ''&(),?;:\/\\|]/_/g;
	}
 return $szChaine;
}
#<dsn>(numerisation d'une date)
sub dsn 
{
 my $szChaine=shift;
 if($szChaine ne "")
	{
   $szChaine = lc($szChaine);
   $szChaine = &trim($szChaine);
   $szChaine = &nac($szChaine);
   $szChaine =~ s/janvier/01/g;
   $szChaine =~ s/fevrier/02/g;
   $szChaine =~ s/mars/03/g;
   $szChaine =~ s/avril/04/g;
   $szChaine =~ s/mai/05/g;
   $szChaine =~ s/juin/06/g;
   $szChaine =~ s/juillet/07/g;
   $szChaine =~ s/aout/08/g;
   $szChaine =~ s/septembre/09/g;
   $szChaine =~ s/octobre/10/g;
   $szChaine =~ s/novembre/11/g;
   $szChaine =~ s/decembre/12/g;

   $szChaine =~ s/january/01/g;
   $szChaine =~ s/february/02/g;
   $szChaine =~ s/march/03/g;
   $szChaine =~ s/april/04/g;
   $szChaine =~ s/may/05/g;
   $szChaine =~ s/june/06/g;
   $szChaine =~ s/july/07/g;
   $szChaine =~ s/august/08/g;
   $szChaine =~ s/september/09/g;
   $szChaine =~ s/october/10/g;
   $szChaine =~ s/november/11/g;
   $szChaine =~ s/december/12/g;

   $szChaine =~ s/jan/01/g;
   $szChaine =~ s/fev/02/g;
   $szChaine =~ s/mar/03/g;
   $szChaine =~ s/avr/04/g;
   $szChaine =~ s/mai/05/g;
   $szChaine =~ s/jui/06/g;
   $szChaine =~ s/jun/06/g;
   $szChaine =~ s/jul/07/g;
   $szChaine =~ s/aou/08/g;
   $szChaine =~ s/sep/09/g;
   $szChaine =~ s/oct/10/g;
   $szChaine =~ s/nov/11/g;
   $szChaine =~ s/dec/12/g;

	}
 return $szChaine;
}
#<GetIP>(get ip)
sub GetIP 
{
 my $szNameServer=shift;
 my $lSepar="[]";
 my $mot;
 if($szNameServer ne "")
	{
	 my $command="ping -4 -n 1 ".$szNameServer;
	 my $res=`$command`;
	 my $pos;
	 my $separ;
	 $pos=sam::MotSuivant(\$res, \$mot ,$lSepar, \$separ ); # lecture du ping jusqu'au crochet ouvrant
	 $pos=sam::MotSuivant(\$res, \$mot ,$lSepar, \$separ ); # lecture du contenu des crochet (adresse IP)
	}
 return $mot;
}
#<GetMAC>(get MAC adress)
sub GetMAC 
{
 my $szIP=shift;
 my $lSepar=" ";
 my $mot;
 if($szIP ne "")
	{
	 my $command="ping -4 -c 1 ".$szIP; # lancement d'un ping sur l'adresse IP pour gnrer des caches arpanet
	 my $res=`$command`;
	 my $command="arp -a"; # liste des caches arpanet
	 my $res=`$command`;
	 my $pos;
	 my $separ;
	 # recherche de l'adresse IP dans les caches arpanet
	 do
		{
		 $pos=sam::MotSuivant(\$res, \$mot ,$lSepar, \$separ); # lecture des mots spar par des blancs
		}
   while($pos && $mot ne $szIP);
   if($szIP eq $mot)
		{
	   # recherche de l'adresse MAC   la suite de l'adresse IP
		 do
			{
			$pos=sam::MotSuivant(\$res, \$mot ,$lSepar, \$separ); # lecture jusqu'au prochain mot non vide: adresse mac
			}
     while($mot eq "");
		}
	}
 return $mot;
#
# sortie de la commande arp -a:
# Interface: 10.210.80.207 --- 0x2
#  Internet Address      Physical Address      Type
#  10.210.80.1           00-07-b4-00-12-01     dynamic   
#  10.210.80.181         00-03-ff-2d-6f-22     dynamic   
#
}
#<GetUC>(get num UC - rcupration du numro d'UC - ncessite la prsence de Portqry dans l'environnement)
sub GetUC 
{
 my $szIP=shift;
 my $lSepar=" ";
 my $mot;
 if($szIP ne "")
	{
	 my $command="portqry -n ".$szIP." -p tcp -e 1024"; # lancement d'un portqry pour rsoudre d'adresse IP port au hasard (on attend NOT LISTEMING)
	 my $res=`$command`;
	 my $pos;
	 my $separ;
	 # recherche de l'adresse IP dans les caches arpanet
	 do
		{
		 $pos=sam::MotSuivant(\$res, \$mot ,$lSepar, \$separ); # lecture des mots spar par des blancs
		}
   while($pos && $mot ne "resolved");
   if($mot eq "resolved")
		{
     $lSepar=" .";
		 $pos=sam::MotSuivant(\$res, \$mot ,$lSepar, \$separ);
     if($mot eq "to")
	    {
		   $pos=sam::MotSuivant(\$res, \$mot ,$lSepar, \$separ); # lecture du premier mot de l'URL: nom du serveur
      }
		}
	}
 return $mot;
#
# sortie de la commande portqry
#
# Querying target system called:
#  10.208.59.168
# Attempting to resolve IP address to a name...
# IP address resolved to po384820.siege.axa-fr.intraxa
# querying...
# TCP port 3389 (ms-wbt-server service): NOT LISTENING
}
#<GetRT>(traceroute avec un seul saut pour vrifier la prsence d'une adresse IP)
# tracert -h 1 172.26.210.11
# Dtermination de l'itinraire vers 172.26.210.11 avec un maximum de 1 sauts.
#   1     4 ms    <1 ms    <1 ms  10.208.58.3
# 	Itinraire dtermin.
sub GetRT 
{
 my $szIP=shift;
 my $lSepar=" ";
 my $mot;
 if($szIP ne "")
	{
	 my $command="tracert -h 1 ".$szIP;
	 my $res=`$command`;
	 my $pos;
	 my $separ;
	 for(my $irt = 0 ; $irt < 5 ; $irt++)
		{
		 $pos=sam::MotSuivant(\$res, \$mot ,$lSepar, \$separ ); # lecture des mots jusqu' l'adresse IP
		}
	}
 return $mot;
}

#<rf>(read file)
sub rf 
{
 my $filenameRF=shift;
 my $nbLigRF=shift;  # numro de la ligne  renvoyer si -1 alors on est dans le cas d'une chane  rechercher
 my $szSearch=shift; # chane de recherche dans une ligne

 my @lines_rf;
 my $szRet = "";

if(open (file_rf, "< $filenameRF"))
  {
   @lines_rf = <file_rf>;
	 $szRet = $lines_rf[$nbLigRF];  
	}
 else
	{
	 $szRet = sprintf("can't open %s",$filenameRF);
	}
 return $szRet;
}
#<tdf>(size of file)
sub tdf
{
my $filename=shift; # chemin du fichier

my $dev;
my $ino;
my $mode;
my $nlink;
my $uid;
my $gid;
my $rdev;
my $size;
my $atime;
my $mtime;
my $ctime;
my $blksize;
my $blocks;

($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,$atime,$mtime,$ctime,$blksize,$blocks) = stat($filename);

if($ino eq "") {$size = "";}

return $size;
}
#<dcf>(date creation file)
sub dcf
{
my $filename=shift; # chemin du fichier
my $date;
my $dev;
my $ino;
my $mode;
my $nlink;
my $uid;
my $gid;
my $rdev;
my $size;
my $atime;
my $mtime;
my $ctime;
my $blksize;
my $blocks;
my $sec;
my $min;
my $hour;
my $mday;
my $mon;
my $year;
my $wday;
my $yday;
my $isdst;

($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,$atime,$mtime,$ctime,$blksize,$blocks) = stat($filename);
($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst)=localtime($ctime);
$year=$year+1900;
$date=sprintf("%02s%02s%02s_%02s%02s%02s",$year,$mon+1,$mday,$hour,$min,$sec);
if($ino eq "") {$date = "";}
return $date;
}
#<dmf>(date modification file)
sub dmf
{
my $filename=shift; # chemin du fichier
my $date;
my $dev;
my $ino;
my $mode;
my $nlink;
my $uid;
my $gid;
my $rdev;
my $size;
my $atime;
my $mtime;
my $ctime;
my $blksize;
my $blocks;
my $sec;
my $min;
my $hour;
my $mday;
my $mon;
my $year;
my $wday;
my $yday;
my $isdst;

($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,$atime,$mtime,$ctime,$blksize,$blocks) = stat($filename);
($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst)=localtime($mtime);
$year=$year+1900;
$date=sprintf("%02s%02s%02s_%02s%02s%02s",$year,$mon+1,$mday,$hour,$min,$sec);
if($ino eq "") {$date = "";}

return $date;
}
#<Dmf>(Date modification file without time) [dmfj] doublons
sub Dmf
{
my $filename=shift; # chemin du fichier
my $date;
my $dev;
my $ino;
my $mode;
my $nlink;
my $uid;
my $gid;
my $rdev;
my $size;
my $atime;
my $mtime;
my $ctime;
my $blksize;
my $blocks;
my $sec;
my $min;
my $hour;
my $mday;
my $mon;
my $year;
my $wday;
my $yday;
my $isdst;

($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,$atime,$mtime,$ctime,$blksize,$blocks) = stat($filename);
($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst)=localtime($mtime);
$year=$year+1900;
$date=sprintf("%02s%02s%02s",$year,$mon+1,$mday);
if($ino eq "") {$date = "";}

return $date;
}
#<dmfhm>(date modification file heure minute)
sub dmfhm
{
my $filename=shift; # chemin du fichier
my $date;
my $dev;
my $ino;
my $mode;
my $nlink;
my $uid;
my $gid;
my $rdev;
my $size;
my $atime;
my $mtime;
my $ctime;
my $blksize;
my $blocks;
my $sec;
my $min;
my $hour;
my $mday;
my $mon;
my $year;
my $wday;
my $yday;
my $isdst;

($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,$atime,$mtime,$ctime,$blksize,$blocks) = stat($filename);
($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst)=localtime($mtime);
$year=$year+1900;
$date=sprintf("%02s%02s%02s_%02s%02s",$year,$mon+1,$mday,$hour,$min);
if($ino eq "") {$date = "";}

return $date;
}
#<dmfh>(date modification file heure)
sub dmfh
{
my $filename=shift; # chemin du fichier
my $date;
my $dev;
my $ino;
my $mode;
my $nlink;
my $uid;
my $gid;
my $rdev;
my $size;
my $atime;
my $mtime;
my $ctime;
my $blksize;
my $blocks;
my $sec;
my $min;
my $hour;
my $mday;
my $mon;
my $year;
my $wday;
my $yday;
my $isdst;

($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,$atime,$mtime,$ctime,$blksize,$blocks) = stat($filename);
($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst)=localtime($mtime);
$year=$year+1900;
$date=sprintf("%02s%02s%02s_%02s",$year,$mon+1,$mday,$hour);
if($ino eq "") {$date = "";}

return $date;
}
#<dmfj>(date modification file jour) [Dmf] doublons
sub dmfj
{
my $filename=shift; # chemin du fichier
my $date;
my $dev;
my $ino;
my $mode;
my $nlink;
my $uid;
my $gid;
my $rdev;
my $size;
my $atime;
my $mtime;
my $ctime;
my $blksize;
my $blocks;
my $sec;
my $min;
my $hour;
my $mday;
my $mon;
my $year;
my $wday;
my $yday;
my $isdst;

($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,$atime,$mtime,$ctime,$blksize,$blocks) = stat($filename);
($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst)=localtime($mtime);
$year=$year+1900;
$date=sprintf("%02s%02s%02s",$year,$mon+1,$mday);
if($ino eq "") {$date = "";}

return $date;
}
#<dmfm>(date modification file mois) [Dmf] doublons
sub dmfm
{
my $filename=shift; # chemin du fichier
my $date;
my $dev;
my $ino;
my $mode;
my $nlink;
my $uid;
my $gid;
my $rdev;
my $size;
my $atime;
my $mtime;
my $ctime;
my $blksize;
my $blocks;
my $sec;
my $min;
my $hour;
my $mday;
my $mon;
my $year;
my $wday;
my $yday;
my $isdst;

($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,$atime,$mtime,$ctime,$blksize,$blocks) = stat($filename);
($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst)=localtime($mtime);
$year=$year+1900;
$date=sprintf("%02s%02s",$year,$mon+1);
if($ino eq "") {$date = "";}

return $date;
}
#<util_pm_fin>(fin du script perl)
1;
