#<wordproc_pl>(traitement de texte batch : word processor)[wordproc_pl_som]

#==========================================================
# mappage d'une commande pour utiliser le script dans vim avec le fichier courant
# xwp pour eXecute Word Processor
# map &xwp :!\%PERL\% wordproc.pl %
#==========================================================

use lib "/home/minage/Documents/mt/fic/pl"; # [use_lib] sous linux mint les ajouts dans @INC par la variable d'environnement PERL5LIB ne semble pas tre pris en compte

#<utilisation_du_module_getopt_wordproc_pl>()
use Getopt::Std;
use sam;

#[isnum]
sub isnum
{
 $_=shift;
if($_ eq "")
 { return 0; }
elsif( tr/[0-9]\.// == length($_))
 { return 1; }
else 
 { return 0; }
}

# La chaine liste_delim permet de controler la definition d'un mot en spcifiant les sparateurs
$liste_delim=" \f\n\t,;:.!?-/*{}[]()|'`\\\"";

$debug=0;

#<traitements_des_arguments_de_la_ligne_de_commande_wordproc_pl>()
getopts('l:m',\%opt); # <options_de_la_ligne_de_commande_wordproc_pl>()
$lglig=$opt{'l'}; # -l largeur de la ligne
if($lglig == 0)
 {$lglig = 95;}
$fmtM=$opt{'m'}; # <fmtM>( format mentor: mise en forme suivant les rgles mentor)
$ficin=$ARGV[1];

#<lecture_du_fichier_d_entre_wordproc_pl>(on lit le fichier spcifi en argv[0] ou stdin)
if (length("$ficin") )
{
 open (STDIN, "< $ficin") || die "can't open $ficin : $!";
}

$nbMot = 0;
$s_lg = 0;
print " ";
# prlecture d'un mot
$ret=sam::San(\$s_mot,$liste_delim,"",\$s_separ);
do
{
 $i_sl = 0; # indicateur de saut de ligne
 $p_separ = $separ; # sparateur d'entre prcdent 
 $p_sep = $sep; # sparateur de sortie prcdent 
 #<lecture_du_mot_suivant_wordproc_pl>(: mot est le mot courant s_mot est le mot suivant idem pour separ et s_separ)
 #squence des variables dans le sens de la lecture: |$p_separ|$mot|$separ|$s_mot|$s_separ
 $mot=$s_mot; $separ=$s_separ; $lg=$s_lg;
 $s_mot = "";
 $ret=sam::San(\$s_mot,$liste_delim,"",\$s_separ);
 #<traitement_du_separateur_wordproc_pl>()
 {
	$sep = $separ; # copie du sparateur en entre pour traitement sur celui de sortie
	# si on rencontre un saut de ligne on considre qu'il s'agit d'un blanc
	if($separ eq "\n")
	 { 
		$sep = " ";
		# mais si il y a deux on garde le saut de ligne avec une ligne vide (deux \n) comme sparation de paragraphe
		if($p_separ eq "\n")
		 {
			$i_sl = 1; # on force le saut de ligne
		 }
	 }
	# remplacement des tabulations par des blancs
	if($separ eq "\t") { $sep = " ";}
	# suppression des rptitions de blancs
	if($mot eq "" and $sep eq " " ) { $sep = "";}
 }
 #<controle_du_saut_de_ligne_wordproc_pl>()
 $s_lg += length($s_mot)+length($s_sep); # la longueur du mot plus le sparateur
 # saut de page par atteinte de la limite de la longueur de ligne
 if( ($s_lg > $lglig or $i_sl == 1) 
	 and !(index("'-",$p_sep) > -1 and $mot ne "") ) # regle3: les mots composs ("d'une","tats-unis") ne sont pas coups
  {
   if($i_sl == 1) {printf("\n");} # regle2: une ligne vide spare un paragraphe
	 $s_lg = 0; printf("\n "); # regle1: le texte est align avec une marge de un blanc  gauche
	}
 # r-introduction de blanc sparateur aprs les virgules et les points et autres caracteres.
 if(&isnum($mot) && &isnum($s_mot)) # si le mot prcdent et le mot suivant sont numrique, il s'agit d'un point dcimal.
  { $blancSep = "";}
 elsif(index("?!:;,.\042\051\135",$sep) > -1 && $sep ne "") 
  { $blancSep = " ";} 
 else { $blancSep = "";}
 # edition du mot et et du separateur en sortie
 printf("%s%s%s",$mot,$sep,$blancSep);
 #printf("[%s|%s]",$mot,$sep);
 $mot = "";
}
while($ret)
